searchData={"items":[{"type":"module","title":"Rivet.Auth","doc":"Public interface to authentication and authorization functions.","ref":"Rivet.Auth.html"},{"type":"function","title":"Rivet.Auth.authz_action/4","doc":"","ref":"Rivet.Auth.html#authz_action/4"},{"type":"function","title":"Rivet.Auth.change_password/2","doc":"","ref":"Rivet.Auth.html#change_password/2"},{"type":"function","title":"Rivet.Auth.change_password/3","doc":"","ref":"Rivet.Auth.html#change_password/3"},{"type":"function","title":"Rivet.Auth.check_authz/2","doc":"","ref":"Rivet.Auth.html#check_authz/2"},{"type":"module","title":"Rivet.Auth.Access","doc":"Validation of tokens for accessing site (after refresh)\n\nNote: this is the start of the next iteration, and it will replace\nRivet.Auth.Token","ref":"Rivet.Auth.Access.html"},{"type":"function","title":"Rivet.Auth.Access.check/2","doc":"iex> alias Rivet.Auth\niex> check([\"\"], %Auth.Domain{})\n{:missing, %Auth.Domain{log: \"Missing authorization header value\"}}\niex> check([], %Auth.Domain{})\n{:missing, %Auth.Domain{log: \"Missing authorization header value\"}}\niex> check([\"bearer token\"], %Auth.Domain{})\n{:error, %Auth.Domain{log: \"Invalid authorization\"}}\niex> check([\"narf\"], %Auth.Domain{})\n{:error, %Auth.Domain{log: \"Authorization header exists but is not formatted properly\"}}\niex> check([\"narf narf\"], %Auth.Domain{})\n{:error, %Auth.Domain{log: \"Invalid authorization type: narf\"}}","ref":"Rivet.Auth.Access.html#check/2"},{"type":"module","title":"Rivet.Auth.Assertion","doc":"Used for standardizing auth assertion checks.\n\nPassed in when declaring what type of auth is needed","ref":"Rivet.Auth.Assertion.html"},{"type":"type","title":"Rivet.Auth.Assertion.t/0","doc":"","ref":"Rivet.Auth.Assertion.html#t:t/0"},{"type":"module","title":"Rivet.Auth.Domain","doc":"Structure for in-process authentication result contexts, not directly to one user","ref":"Rivet.Auth.Domain.html"},{"type":"type","title":"Rivet.Auth.Domain.result/0","doc":"","ref":"Rivet.Auth.Domain.html#t:result/0"},{"type":"type","title":"Rivet.Auth.Domain.t/0","doc":"","ref":"Rivet.Auth.Domain.html#t:t/0"},{"type":"module","title":"Rivet.Auth.Graphql","doc":"Helpers for Graphql resolvers.","ref":"Rivet.Auth.Graphql.html"},{"type":"function","title":"Rivet.Auth.Graphql.action/2","doc":"","ref":"Rivet.Auth.Graphql.html#action/2"},{"type":"function","title":"Rivet.Auth.Graphql.authz/4","doc":"This wraps check_authz with logging and creates normal error output for\nAbsinthe to handle.\n\n    with {:ok, authed} <- authz(context, %Rivet.Auth.Assertion{}, \"doTheThing\") do\n      handle success\n    end","ref":"Rivet.Auth.Graphql.html#authz/4"},{"type":"function","title":"Rivet.Auth.Graphql.authz_user/4","doc":"Accept authorization from a user.\nPunt to authz_action(), but log graphql bits.","ref":"Rivet.Auth.Graphql.html#authz_user/4"},{"type":"function","title":"Rivet.Auth.Graphql.check_authz/2","doc":"check_authz/2 attempts to verify %Auth.Assertion{} against the specified user,\nand if the assertion includes a domain reference, it will attempt to walk\nup the reference tree (if a parent_id exists) and try checking auth again.","ref":"Rivet.Auth.Graphql.html#check_authz/2"},{"type":"function","title":"Rivet.Auth.Graphql.current_user/1","doc":"Handles extracting the current user from the Absinthe context, and then will\neither call `func` and pass in the current user or return an error if there is\nno user in the context","ref":"Rivet.Auth.Graphql.html#current_user/1"},{"type":"function","title":"Rivet.Auth.Graphql.current_user/2","doc":"","ref":"Rivet.Auth.Graphql.html#current_user/2"},{"type":"type","title":"Rivet.Auth.Graphql.az_assertion/0","doc":"","ref":"Rivet.Auth.Graphql.html#t:az_assertion/0"},{"type":"type","title":"Rivet.Auth.Graphql.az_log/0","doc":"","ref":"Rivet.Auth.Graphql.html#t:az_log/0"},{"type":"type","title":"Rivet.Auth.Graphql.az_user/0","doc":"","ref":"Rivet.Auth.Graphql.html#t:az_user/0"},{"type":"module","title":"Rivet.Auth.Identify","doc":"","ref":"Rivet.Auth.Identify.html"},{"type":"function","title":"Rivet.Auth.Identify.identify/2","doc":"","ref":"Rivet.Auth.Identify.html#identify/2"},{"type":"module","title":"Rivet.Auth.Refresh","doc":"Tooling for the second phase of auth: Refresh\n\nTODO: Extract from Phoenix/WebSvc better, abstract so conn isn't needed\n      This will require a module that is imported into WebSvc -BJG","ref":"Rivet.Auth.Refresh.html"},{"type":"function","title":"Rivet.Auth.Refresh.assure/2","doc":"1. extract the validaton token from the refresh token\n2. decode & verify the validation token is ours & good\n3. using the sub:uuid from the validation token, verify the signature on the ref token\n4. update connection data (or abort)\n\niex> assure(%Auth.Domain{}, nil)\n{:error, %Auth.Domain{log: \"Invalid refresh request\"}}","ref":"Rivet.Auth.Refresh.html#assure/2"},{"type":"function","title":"Rivet.Auth.Refresh.check_refresh_token/1","doc":"iex> {:error, \"narf!\"} = check_refresh_token({:error, \"narf!\"})","ref":"Rivet.Auth.Refresh.html#check_refresh_token/1"},{"type":"function","title":"Rivet.Auth.Refresh.extract_validation_token/2","doc":"iex> {:error, %Auth.Domain{log: \"Invalid authorization\"}} = extract_validation_token({:ok, %{sub: \"cas2:asdf\"}}, %Auth.Domain{})\niex> {:error, %Auth.Domain{log: \"Unable to match validation token subject: \\\"wut\\\"\"}} = extract_validation_token({:ok, \"wut\"}, %Auth.Domain{})\niex> {:error, %Auth.Domain{log: \"narf!\"}} = extract_validation_token({:error, \"narf!\"}, %Auth.Domain{})","ref":"Rivet.Auth.Refresh.html#extract_validation_token/2"},{"type":"module","title":"Rivet.Auth.Settings","doc":"How we are configured globally","ref":"Rivet.Auth.Settings.html"},{"type":"function","title":"Rivet.Auth.Settings.current_jwt_secret/1","doc":"Get the most current secret based on token type(:acc, :val etc..), for jwt hashes","ref":"Rivet.Auth.Settings.html#current_jwt_secret/1"},{"type":"function","title":"Rivet.Auth.Settings.decode_secrets/1","doc":"Called by Application.start, to configure the runtime state from other sources","ref":"Rivet.Auth.Settings.html#decode_secrets/1"},{"type":"function","title":"Rivet.Auth.Settings.expire_limit/2","doc":"","ref":"Rivet.Auth.Settings.html#expire_limit/2"},{"type":"function","title":"Rivet.Auth.Settings.getcfg/2","doc":"","ref":"Rivet.Auth.Settings.html#getcfg/2"},{"type":"function","title":"Rivet.Auth.Settings.putcfg/2","doc":"","ref":"Rivet.Auth.Settings.html#putcfg/2"},{"type":"function","title":"Rivet.Auth.Settings.secret_keys/1","doc":"","ref":"Rivet.Auth.Settings.html#secret_keys/1"},{"type":"function","title":"Rivet.Auth.Settings.start/0","doc":"","ref":"Rivet.Auth.Settings.html#start/0"},{"type":"module","title":"Rivet.Auth.Signin","doc":"","ref":"Rivet.Auth.Signin.html"},{"type":"function","title":"Rivet.Auth.Signin.post_signin/1","doc":"","ref":"Rivet.Auth.Signin.html#post_signin/1"},{"type":"module","title":"Rivet.Auth.Signin.Google","doc":"Google login scheme","ref":"Rivet.Auth.Signin.Google.html"},{"type":"function","title":"Rivet.Auth.Signin.Google.check/2","doc":"","ref":"Rivet.Auth.Signin.Google.html#check/2"},{"type":"module","title":"Rivet.Auth.Signin.Google.AuthKeys","doc":"Syntactic sugar to wrap the HTTP call in requesting the keys.  Questionable\nif this is worthwhile, but it's working now...","ref":"Rivet.Auth.Signin.Google.AuthKeys.html"},{"type":"function","title":"Rivet.Auth.Signin.Google.AuthKeys.get!/1","doc":"","ref":"Rivet.Auth.Signin.Google.AuthKeys.html#get!/1"},{"type":"module","title":"Rivet.Auth.Signin.Google.KeyManager","doc":"This module runs as a separate process which keeps google's oauth public keys\ncurrent, as they change weekly.  This process inspects the expiration date\n(which google says should be correct) and updates at least by then, but does\nnot wait longer than 1 day.","ref":"Rivet.Auth.Signin.Google.KeyManager.html"},{"type":"function","title":"Rivet.Auth.Signin.Google.KeyManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rivet.Auth.Signin.Google.KeyManager.html#child_spec/1"},{"type":"function","title":"Rivet.Auth.Signin.Google.KeyManager.get_keys/0","doc":"External interface to request a current copy of the keys for google\n\niex> dict = Rivet.Auth.Signin.Google.KeyManager.get_keys()\niex> is_map(dict)\ntrue","ref":"Rivet.Auth.Signin.Google.KeyManager.html#get_keys/0"},{"type":"function","title":"Rivet.Auth.Signin.Google.KeyManager.init/1","doc":"","ref":"Rivet.Auth.Signin.Google.KeyManager.html#init/1"},{"type":"function","title":"Rivet.Auth.Signin.Google.KeyManager.start_link/1","doc":"","ref":"Rivet.Auth.Signin.Google.KeyManager.html#start_link/1"},{"type":"module","title":"Rivet.Auth.Signin.Local","doc":"Local login scheme","ref":"Rivet.Auth.Signin.Local.html"},{"type":"function","title":"Rivet.Auth.Signin.Local.check/2","doc":"","ref":"Rivet.Auth.Signin.Local.html#check/2"},{"type":"function","title":"Rivet.Auth.Signin.Local.check_password/2","doc":"","ref":"Rivet.Auth.Signin.Local.html#check_password/2"},{"type":"function","title":"Rivet.Auth.Signin.Local.load_password_factor/1","doc":"","ref":"Rivet.Auth.Signin.Local.html#load_password_factor/1"},{"type":"function","title":"Rivet.Auth.Signin.Local.load_user/2","doc":"","ref":"Rivet.Auth.Signin.Local.html#load_user/2"},{"type":"function","title":"Rivet.Auth.Signin.Local.signup/2","doc":"","ref":"Rivet.Auth.Signin.Local.html#signup/2"},{"type":"function","title":"Rivet.Auth.Signin.Local.valid_user_factor/2","doc":"","ref":"Rivet.Auth.Signin.Local.html#valid_user_factor/2"},{"type":"module","title":"Rivet.Auth.Token","doc":"","ref":"Rivet.Auth.Token.html"},{"type":"function","title":"Rivet.Auth.Token.extract/2","doc":"iex> jwt = \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOiJjYWExOmFjYzpleGFtcGxlLmNvbSIsImV4cCI6MTY3MTkyMjMwMCwiZm9yIjp7fSwic3ViIjoiY2FzMTpuYXJmIn0.N6PV_XAGTjymi1CEfVkKRj433S0XBlTxcevL7VAhTRY\"\niex> extract(jwt, :all)\n{:ok, %{\"alg\" => \"HS256\",\"typ\" => \"JWT\"}, %{aud: \"caa1:acc:example.com\", exp: 1671922300, for: %{}, sub: \"cas1:narf\"}}\niex> extract(jwt, :claims)\n{:ok, %{aud: \"caa1:acc:example.com\", exp: 1671922300, for: %{}, sub: \"cas1:narf\"}}\niex> extract(jwt, :header)\n{:ok, %{\"alg\" => \"HS256\",\"typ\" => \"JWT\"}}\niex> extract(\"asdf\", :all)\n{:error, \"Invalid JWT, cannot extract claims\"}\niex> extract(\"asdf.asdf.asdf\", :all)\n{:error, \"Unable to decode JWT part: asdf\"}","ref":"Rivet.Auth.Token.html#extract/2"},{"type":"module","title":"Rivet.Auth.Token.Access","doc":"","ref":"Rivet.Auth.Token.Access.html"},{"type":"function","title":"Rivet.Auth.Token.Access.jwt/3","doc":"Generate an auth JWT to our specification\n\niex> alias Rivet.Ident.Factor\niex> {:ok, token, claims} = jwt(%Factor{id: \"AB\", details: %{type: \"acc\"}}, \"example.com\", 5*60)\niex> claims.aud\n\"caa1:acc:example.com\"\niex> claims.sub\n\"cas1:AB\"\niex> String.slice(token, 0..1)\n\"ey\"\n\niex> {:ok, token, claims} = jwt(\"narf\", \"example.com\", 5*60)\niex> claims.aud\n\"caa1:acc:example.com\"\niex> claims.sub\n\"cas1:narf\"\niex> String.slice(token, 0..1)\n\"ey\"\n\niex> {:ok, \"ey\"   _rest, %{sub: \"cas1:userid\"}} = jwt(\"userid\", \"hostname\")","ref":"Rivet.Auth.Token.Access.html#jwt/3"},{"type":"module","title":"Rivet.Auth.Token.Check","doc":"Validate tokens are meeting our requirements","ref":"Rivet.Auth.Token.Check.html"},{"type":"function","title":"Rivet.Auth.Token.Check.enrich_sub_aud/1","doc":"iex> alias Rivet.Ident.Auth.Domain\niex> {:error, auth} = enrich_sub_aud(%Auth.Domain{token: %{claims: %{sub: \"asdf\", aud: \"asdf\"}}})\niex> auth.log\n\"Cannot parse token.sub=asdf\"","ref":"Rivet.Auth.Token.Check.html#enrich_sub_aud/1"},{"type":"function","title":"Rivet.Auth.Token.Check.jwt/1","doc":"Checks payload information to verify proper authorization matches\n\niex> {:ok, _token, claims} = Rivet.Auth.Token.Access.jwt(\"narf\", \"example.com\", 5)\n...> {:error, %Auth.Domain{} = a} = jwt(%Auth.Domain{hostname: \"example.com\", token: %{claims: claims}})\n...> a.log\n\"Cannot find identity factor=narf\"","ref":"Rivet.Auth.Token.Check.html#jwt/1"},{"type":"function","title":"Rivet.Auth.Token.Check.valid_audience/1","doc":"iex> alias Rivet.Ident.Auth.Domain\niex> {:error, auth} = valid_audience(%Auth.Domain{token: %{aud: \"asdf\"}})\niex> auth.log\n\"Cannot parse token.tok=asdf\"\niex> {:error, auth} = valid_audience(%Auth.Domain{token: %{aud: \"key:a.domain\"}, hostname: \"b.domain\"})\niex> auth.log\n\"Token audience does not match: a.domain != b.domain\"\niex> valid_audience({:error, \"narf\"})\n{:error, \"narf\"}","ref":"Rivet.Auth.Token.Check.html#valid_audience/1"},{"type":"function","title":"Rivet.Auth.Token.Check.valid_expiration/1","doc":"iex> alias Rivet.Ident.Auth.Domain\niex> now = System.os_time(:second)\niex> {:error, auth} = valid_expiration(%Auth.Domain{token: %{claims: %{for: %{}, exp: 0}}, type: :acc})\niex> auth.log\n\"Token Expired\"\niex> {:error, auth} = valid_expiration(%Auth.Domain{token: %{claims: %{for: %{}, exp: now+300000}}, type: :acc})\niex> auth.log\n\"Token expiration out of bounds\"\niex> valid_expiration({:error, \"narf\"})\n{:error, \"narf\"}","ref":"Rivet.Auth.Token.Check.html#valid_expiration/1"},{"type":"function","title":"Rivet.Auth.Token.Check.valid_subject/1","doc":"iex> alias Rivet.Ident.Auth.Domain\niex> {:error, auth} = valid_subject(%Auth.Domain{})\niex> auth.log\n\"Unable to process token subject\"\niex> {:error, auth} = valid_subject(%Auth.Domain{token: %{claims: %{sub: \"red\"}}, type: :acc})\niex> auth.log\n\"Cannot parse token.sub=red\"\niex> {:error, auth} = valid_subject(%Auth.Domain{type: :acc, token: %{sub_type: :cas1, sub: \"subject\"}})\niex> auth.log\n\"Cannot find identity factor=subject\"\niex> {:error, auth} = valid_subject(%Auth.Domain{token: %{aud_type: :caa1, sub_type: :cas1, sub: \"subject\"}, type: :val})\niex> auth.log\n\"Cannot find identity factor=subject\"\niex> valid_subject({:error, \"narf\"})\n{:error, \"narf\"}","ref":"Rivet.Auth.Token.Check.html#valid_subject/1"},{"type":"module","title":"Rivet.Auth.Token.Create","doc":"","ref":"Rivet.Auth.Token.Create.html"},{"type":"function","title":"Rivet.Auth.Token.Create.jwt/7","doc":"iex> {:ok, _tok, claims} = jwt(:acc, \"narf\", \"NARF\", 10, \"narf\", %{})\niex> claims.aud\n\"caa1:acc:NARF\"","ref":"Rivet.Auth.Token.Create.html#jwt/7"},{"type":"module","title":"Rivet.Auth.Token.Validation","doc":"","ref":"Rivet.Auth.Token.Validation.html"},{"type":"function","title":"Rivet.Auth.Token.Validation.jwt/4","doc":"","ref":"Rivet.Auth.Token.Validation.html#jwt/4"},{"type":"function","title":"Rivet.Auth.Token.Validation.key/2","doc":"","ref":"Rivet.Auth.Token.Validation.html#key/2"},{"type":"module","title":"Rivet.Auth.Token.Verify","doc":"Verify tokens meet our requirements","ref":"Rivet.Auth.Token.Verify.html"},{"type":"function","title":"Rivet.Auth.Token.Verify.jwt/2","doc":"Checks JWT against configured secrets for that type. Returns claims if a\nvalid JWT is found, but does no authentication/authorization.\n\nNOTE: These test will stop working with diff jwt keys\n\niex> jwt(\"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOiJjYWExOmFjYzpleGFtcGxlLmNvbSIsImV4cCI6MTY3ODMxMTEwMywiZm9yIjp7fSwic3ViIjoiY2FzMTpuYXJmIn0.qMH6Tr_vvfQ4lmLnPilordYbfgv4ZDzCY2yAc8D8RVQ\", :acc)\n{:ok, %{aud: \"caa1:acc:example.com\", exp: 1678311103, for: %{}, sub: \"cas1:narf\"}}","ref":"Rivet.Auth.Token.Verify.html#jwt/2"},{"type":"module","title":"Rivet.Ident.Access","doc":"Schema for representing and working with a Ident.Access.","ref":"Rivet.Ident.Access.html"},{"type":"function","title":"Rivet.Ident.Access.aggregate/2","doc":"","ref":"Rivet.Ident.Access.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Access.all/2","doc":"","ref":"Rivet.Ident.Access.html#all/2"},{"type":"function","title":"Rivet.Ident.Access.all!/2","doc":"","ref":"Rivet.Ident.Access.html#all!/2"},{"type":"function","title":"Rivet.Ident.Access.associate/3","doc":"","ref":"Rivet.Ident.Access.html#associate/3"},{"type":"function","title":"Rivet.Ident.Access.build/1","doc":"","ref":"Rivet.Ident.Access.html#build/1"},{"type":"function","title":"Rivet.Ident.Access.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Access.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Access.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Access.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Access.changeset/2","doc":"","ref":"Rivet.Ident.Access.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Access.count!/0","doc":"","ref":"Rivet.Ident.Access.html#count!/0"},{"type":"function","title":"Rivet.Ident.Access.count!/1","doc":"","ref":"Rivet.Ident.Access.html#count!/1"},{"type":"function","title":"Rivet.Ident.Access.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Access.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Access.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Access.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Access.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Access.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Access.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Access.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Access.create/1","doc":"","ref":"Rivet.Ident.Access.html#create/1"},{"type":"function","title":"Rivet.Ident.Access.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Access.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Access.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Access.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Access.delete/1","doc":"","ref":"Rivet.Ident.Access.html#delete/1"},{"type":"function","title":"Rivet.Ident.Access.delete_all/2","doc":"","ref":"Rivet.Ident.Access.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Access.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Access.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Access.drop_replace/2","doc":"","ref":"Rivet.Ident.Access.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Access.exists?/1","doc":"","ref":"Rivet.Ident.Access.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Access.full_table_scan/2","doc":"","ref":"Rivet.Ident.Access.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Access.insert/2","doc":"","ref":"Rivet.Ident.Access.html#insert/2"},{"type":"function","title":"Rivet.Ident.Access.latest/2","doc":"","ref":"Rivet.Ident.Access.html#latest/2"},{"type":"function","title":"Rivet.Ident.Access.latest!/2","doc":"","ref":"Rivet.Ident.Access.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Access.one/2","doc":"","ref":"Rivet.Ident.Access.html#one/2"},{"type":"function","title":"Rivet.Ident.Access.one!/2","doc":"","ref":"Rivet.Ident.Access.html#one!/2"},{"type":"function","title":"Rivet.Ident.Access.preload/3","doc":"","ref":"Rivet.Ident.Access.html#preload/3"},{"type":"function","title":"Rivet.Ident.Access.preload!/3","doc":"","ref":"Rivet.Ident.Access.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Access.replace/2","doc":"","ref":"Rivet.Ident.Access.html#replace/2"},{"type":"function","title":"Rivet.Ident.Access.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Access.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Access.stream/2","doc":"","ref":"Rivet.Ident.Access.html#stream/2"},{"type":"function","title":"Rivet.Ident.Access.stream_all!/2","doc":"","ref":"Rivet.Ident.Access.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Access.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Access.html#touch/1"},{"type":"function","title":"Rivet.Ident.Access.unload/1","doc":"","ref":"Rivet.Ident.Access.html#unload/1"},{"type":"function","title":"Rivet.Ident.Access.unload/2","doc":"","ref":"Rivet.Ident.Access.html#unload/2"},{"type":"function","title":"Rivet.Ident.Access.update/2","doc":"","ref":"Rivet.Ident.Access.html#update/2"},{"type":"function","title":"Rivet.Ident.Access.update!/2","doc":"","ref":"Rivet.Ident.Access.html#update!/2"},{"type":"function","title":"Rivet.Ident.Access.update_all/2","doc":"","ref":"Rivet.Ident.Access.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Access.update_fill/2","doc":"","ref":"Rivet.Ident.Access.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Access.upsert/2","doc":"","ref":"Rivet.Ident.Access.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Access.validate/1","doc":"","ref":"Rivet.Ident.Access.html#validate/1"},{"type":"type","title":"Rivet.Ident.Access.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Access.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Access.id/0","doc":"","ref":"Rivet.Ident.Access.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Access.model_p_result/0","doc":"","ref":"Rivet.Ident.Access.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Access.t/0","doc":"","ref":"Rivet.Ident.Access.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Access.Domains","doc":"","ref":"Rivet.Ident.Access.Domains.html"},{"type":"function","title":"Rivet.Ident.Access.Domains.cast/1","doc":"","ref":"Rivet.Ident.Access.Domains.html#cast/1"},{"type":"function","title":"Rivet.Ident.Access.Domains.dump/1","doc":"","ref":"Rivet.Ident.Access.Domains.html#dump/1"},{"type":"function","title":"Rivet.Ident.Access.Domains.embed_as/1","doc":"","ref":"Rivet.Ident.Access.Domains.html#embed_as/1"},{"type":"function","title":"Rivet.Ident.Access.Domains.equal?/2","doc":"","ref":"Rivet.Ident.Access.Domains.html#equal?/2"},{"type":"function","title":"Rivet.Ident.Access.Domains.load/1","doc":"","ref":"Rivet.Ident.Access.Domains.html#load/1"},{"type":"function","title":"Rivet.Ident.Access.Domains.type/0","doc":"","ref":"Rivet.Ident.Access.Domains.html#type/0"},{"type":"function","title":"Rivet.Ident.Access.Domains.valid_value?/1","doc":"","ref":"Rivet.Ident.Access.Domains.html#valid_value?/1"},{"type":"type","title":"Rivet.Ident.Access.Domains.t/0","doc":"","ref":"Rivet.Ident.Access.Domains.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Access.Lib","doc":"","ref":"Rivet.Ident.Access.Lib.html"},{"type":"function","title":"Rivet.Ident.Access.Lib.add/3","doc":"","ref":"Rivet.Ident.Access.Lib.html#add/3"},{"type":"function","title":"Rivet.Ident.Access.Lib.delete_by_user/1","doc":"","ref":"Rivet.Ident.Access.Lib.html#delete_by_user/1"},{"type":"function","title":"Rivet.Ident.Access.Lib.delete_by_user/3","doc":"","ref":"Rivet.Ident.Access.Lib.html#delete_by_user/3"},{"type":"function","title":"Rivet.Ident.Access.Lib.drop/3","doc":"","ref":"Rivet.Ident.Access.Lib.html#drop/3"},{"type":"function","title":"Rivet.Ident.Access.Lib.get_actions/1","doc":"Fold a list of accesses into a set of actions, using memory cache","ref":"Rivet.Ident.Access.Lib.html#get_actions/1"},{"type":"function","title":"Rivet.Ident.Access.Lib.get_actions/3","doc":"","ref":"Rivet.Ident.Access.Lib.html#get_actions/3"},{"type":"type","title":"Rivet.Ident.Access.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Access.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Access.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Access.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.Action","doc":"Schema for representing and working with a Ident.Action.","ref":"Rivet.Ident.Action.html"},{"type":"function","title":"Rivet.Ident.Action.aggregate/2","doc":"","ref":"Rivet.Ident.Action.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Action.all/2","doc":"","ref":"Rivet.Ident.Action.html#all/2"},{"type":"function","title":"Rivet.Ident.Action.all!/2","doc":"","ref":"Rivet.Ident.Action.html#all!/2"},{"type":"function","title":"Rivet.Ident.Action.associate/3","doc":"","ref":"Rivet.Ident.Action.html#associate/3"},{"type":"function","title":"Rivet.Ident.Action.build/1","doc":"","ref":"Rivet.Ident.Action.html#build/1"},{"type":"function","title":"Rivet.Ident.Action.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Action.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Action.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Action.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Action.changeset/2","doc":"","ref":"Rivet.Ident.Action.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Action.count!/0","doc":"","ref":"Rivet.Ident.Action.html#count!/0"},{"type":"function","title":"Rivet.Ident.Action.count!/1","doc":"","ref":"Rivet.Ident.Action.html#count!/1"},{"type":"function","title":"Rivet.Ident.Action.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Action.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Action.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Action.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Action.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Action.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Action.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Action.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Action.create/1","doc":"","ref":"Rivet.Ident.Action.html#create/1"},{"type":"function","title":"Rivet.Ident.Action.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Action.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Action.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Action.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Action.delete/1","doc":"","ref":"Rivet.Ident.Action.html#delete/1"},{"type":"function","title":"Rivet.Ident.Action.delete_all/2","doc":"","ref":"Rivet.Ident.Action.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Action.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Action.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Action.drop_replace/2","doc":"","ref":"Rivet.Ident.Action.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Action.exists?/1","doc":"","ref":"Rivet.Ident.Action.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Action.full_table_scan/2","doc":"","ref":"Rivet.Ident.Action.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Action.insert/2","doc":"","ref":"Rivet.Ident.Action.html#insert/2"},{"type":"function","title":"Rivet.Ident.Action.latest/2","doc":"","ref":"Rivet.Ident.Action.html#latest/2"},{"type":"function","title":"Rivet.Ident.Action.latest!/2","doc":"","ref":"Rivet.Ident.Action.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Action.one/2","doc":"","ref":"Rivet.Ident.Action.html#one/2"},{"type":"function","title":"Rivet.Ident.Action.one!/2","doc":"","ref":"Rivet.Ident.Action.html#one!/2"},{"type":"function","title":"Rivet.Ident.Action.preload/3","doc":"","ref":"Rivet.Ident.Action.html#preload/3"},{"type":"function","title":"Rivet.Ident.Action.preload!/3","doc":"","ref":"Rivet.Ident.Action.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Action.replace/2","doc":"","ref":"Rivet.Ident.Action.html#replace/2"},{"type":"function","title":"Rivet.Ident.Action.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Action.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Action.stream/2","doc":"","ref":"Rivet.Ident.Action.html#stream/2"},{"type":"function","title":"Rivet.Ident.Action.stream_all!/2","doc":"","ref":"Rivet.Ident.Action.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Action.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Action.html#touch/1"},{"type":"function","title":"Rivet.Ident.Action.unload/1","doc":"","ref":"Rivet.Ident.Action.html#unload/1"},{"type":"function","title":"Rivet.Ident.Action.unload/2","doc":"","ref":"Rivet.Ident.Action.html#unload/2"},{"type":"function","title":"Rivet.Ident.Action.update/2","doc":"","ref":"Rivet.Ident.Action.html#update/2"},{"type":"function","title":"Rivet.Ident.Action.update!/2","doc":"","ref":"Rivet.Ident.Action.html#update!/2"},{"type":"function","title":"Rivet.Ident.Action.update_all/2","doc":"","ref":"Rivet.Ident.Action.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Action.update_fill/2","doc":"","ref":"Rivet.Ident.Action.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Action.upsert/2","doc":"","ref":"Rivet.Ident.Action.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Action.validate/1","doc":"","ref":"Rivet.Ident.Action.html#validate/1"},{"type":"type","title":"Rivet.Ident.Action.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Action.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Action.id/0","doc":"","ref":"Rivet.Ident.Action.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Action.model_p_result/0","doc":"","ref":"Rivet.Ident.Action.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Action.t/0","doc":"","ref":"Rivet.Ident.Action.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Action.Lib","doc":"","ref":"Rivet.Ident.Action.Lib.html"},{"type":"type","title":"Rivet.Ident.Action.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Action.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Action.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Action.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.Application","doc":"","ref":"Rivet.Ident.Application.html"},{"type":"function","title":"Rivet.Ident.Application.start/2","doc":"","ref":"Rivet.Ident.Application.html#start/2"},{"type":"module","title":"Rivet.Ident.Email","doc":"Schema for representing and working with a Ident.Email.","ref":"Rivet.Ident.Email.html"},{"type":"function","title":"Rivet.Ident.Email.aggregate/2","doc":"","ref":"Rivet.Ident.Email.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Email.all/2","doc":"","ref":"Rivet.Ident.Email.html#all/2"},{"type":"function","title":"Rivet.Ident.Email.all!/2","doc":"","ref":"Rivet.Ident.Email.html#all!/2"},{"type":"function","title":"Rivet.Ident.Email.associate/3","doc":"","ref":"Rivet.Ident.Email.html#associate/3"},{"type":"function","title":"Rivet.Ident.Email.build/1","doc":"","ref":"Rivet.Ident.Email.html#build/1"},{"type":"function","title":"Rivet.Ident.Email.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Email.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Email.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Email.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Email.changeset/2","doc":"","ref":"Rivet.Ident.Email.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Email.count!/0","doc":"","ref":"Rivet.Ident.Email.html#count!/0"},{"type":"function","title":"Rivet.Ident.Email.count!/1","doc":"","ref":"Rivet.Ident.Email.html#count!/1"},{"type":"function","title":"Rivet.Ident.Email.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Email.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Email.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Email.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Email.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Email.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Email.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Email.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Email.create/1","doc":"","ref":"Rivet.Ident.Email.html#create/1"},{"type":"function","title":"Rivet.Ident.Email.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Email.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Email.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Email.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Email.delete/1","doc":"","ref":"Rivet.Ident.Email.html#delete/1"},{"type":"function","title":"Rivet.Ident.Email.delete_all/2","doc":"","ref":"Rivet.Ident.Email.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Email.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Email.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Email.drop_replace/2","doc":"","ref":"Rivet.Ident.Email.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Email.exists?/1","doc":"","ref":"Rivet.Ident.Email.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Email.full_table_scan/2","doc":"","ref":"Rivet.Ident.Email.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Email.insert/2","doc":"","ref":"Rivet.Ident.Email.html#insert/2"},{"type":"function","title":"Rivet.Ident.Email.latest/2","doc":"","ref":"Rivet.Ident.Email.html#latest/2"},{"type":"function","title":"Rivet.Ident.Email.latest!/2","doc":"","ref":"Rivet.Ident.Email.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Email.one/2","doc":"","ref":"Rivet.Ident.Email.html#one/2"},{"type":"function","title":"Rivet.Ident.Email.one!/2","doc":"","ref":"Rivet.Ident.Email.html#one!/2"},{"type":"function","title":"Rivet.Ident.Email.preload/3","doc":"","ref":"Rivet.Ident.Email.html#preload/3"},{"type":"function","title":"Rivet.Ident.Email.preload!/3","doc":"","ref":"Rivet.Ident.Email.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Email.replace/2","doc":"","ref":"Rivet.Ident.Email.html#replace/2"},{"type":"function","title":"Rivet.Ident.Email.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Email.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Email.stream/2","doc":"","ref":"Rivet.Ident.Email.html#stream/2"},{"type":"function","title":"Rivet.Ident.Email.stream_all!/2","doc":"","ref":"Rivet.Ident.Email.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Email.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Email.html#touch/1"},{"type":"function","title":"Rivet.Ident.Email.unload/1","doc":"","ref":"Rivet.Ident.Email.html#unload/1"},{"type":"function","title":"Rivet.Ident.Email.unload/2","doc":"","ref":"Rivet.Ident.Email.html#unload/2"},{"type":"function","title":"Rivet.Ident.Email.update/2","doc":"","ref":"Rivet.Ident.Email.html#update/2"},{"type":"function","title":"Rivet.Ident.Email.update!/2","doc":"","ref":"Rivet.Ident.Email.html#update!/2"},{"type":"function","title":"Rivet.Ident.Email.update_all/2","doc":"","ref":"Rivet.Ident.Email.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Email.update_fill/2","doc":"","ref":"Rivet.Ident.Email.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Email.upsert/2","doc":"","ref":"Rivet.Ident.Email.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Email.validate/1","doc":"","ref":"Rivet.Ident.Email.html#validate/1"},{"type":"type","title":"Rivet.Ident.Email.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Email.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Email.id/0","doc":"","ref":"Rivet.Ident.Email.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Email.model_p_result/0","doc":"","ref":"Rivet.Ident.Email.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Email.t/0","doc":"","ref":"Rivet.Ident.Email.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Email.Lib","doc":"","ref":"Rivet.Ident.Email.Lib.html"},{"type":"function","title":"Rivet.Ident.Email.Lib.send_reset_code/1","doc":"","ref":"Rivet.Ident.Email.Lib.html#send_reset_code/1"},{"type":"function","title":"Rivet.Ident.Email.Lib.with_email/3","doc":"Helper function which accepts either user_id or user, and calls the passed\nfunction with the user model loaded including any preloads.  Send preloads\nas [] if none are desired.","ref":"Rivet.Ident.Email.Lib.html#with_email/3"},{"type":"type","title":"Rivet.Ident.Email.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Email.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Email.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Email.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.Example.Mailer","doc":"This is an example of how to deploy Rivet Email, and is included so other\nprojects may include it in their tests.","ref":"Rivet.Ident.Example.Mailer.html"},{"type":"function","title":"Rivet.Ident.Example.Mailer.deliver/3","doc":"","ref":"Rivet.Ident.Example.Mailer.html#deliver/3"},{"type":"function","title":"Rivet.Ident.Example.Mailer.get_emails/2","doc":"","ref":"Rivet.Ident.Example.Mailer.html#get_emails/2"},{"type":"function","title":"Rivet.Ident.Example.Mailer.log_email/1","doc":"","ref":"Rivet.Ident.Example.Mailer.html#log_email/1"},{"type":"function","title":"Rivet.Ident.Example.Mailer.send/3","doc":"","ref":"Rivet.Ident.Example.Mailer.html#send/3"},{"type":"function","title":"Rivet.Ident.Example.Mailer.send_email/1","doc":"","ref":"Rivet.Ident.Example.Mailer.html#send_email/1"},{"type":"type","title":"Rivet.Ident.Example.Mailer.email_model/0","doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:email_model/0"},{"type":"type","title":"Rivet.Ident.Example.Mailer.email_recipient/0","doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:email_recipient/0"},{"type":"type","title":"Rivet.Ident.Example.Mailer.user_id/0","doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:user_id/0"},{"type":"type","title":"Rivet.Ident.Example.Mailer.user_model/0","doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:user_model/0"},{"type":"module","title":"Rivet.Ident.Example.Mailer.Backend","doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html"},{"type":"function","title":"Rivet.Ident.Example.Mailer.Backend.deliver/2","doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver/2"},{"type":"function","title":"Rivet.Ident.Example.Mailer.Backend.deliver!/2","doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver!/2"},{"type":"function","title":"Rivet.Ident.Example.Mailer.Backend.deliver_many/2","doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver_many/2"},{"type":"module","title":"Rivet.Ident.Example.Mailer.Template","doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html"},{"type":"function","title":"Rivet.Ident.Example.Mailer.Template.eval/3","doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html#eval/3"},{"type":"function","title":"Rivet.Ident.Example.Mailer.Template.load_and_eval/2","doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html#load_and_eval/2"},{"type":"module","title":"Rivet.Ident.Factor","doc":"Schema for representing and working with an AuthFactor.","ref":"Rivet.Ident.Factor.html"},{"type":"function","title":"Rivet.Ident.Factor.aggregate/2","doc":"","ref":"Rivet.Ident.Factor.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Factor.all/2","doc":"","ref":"Rivet.Ident.Factor.html#all/2"},{"type":"function","title":"Rivet.Ident.Factor.all!/2","doc":"","ref":"Rivet.Ident.Factor.html#all!/2"},{"type":"function","title":"Rivet.Ident.Factor.associate/3","doc":"","ref":"Rivet.Ident.Factor.html#associate/3"},{"type":"function","title":"Rivet.Ident.Factor.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Factor.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Factor.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Factor.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Factor.changeset/2","doc":"","ref":"Rivet.Ident.Factor.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Factor.count!/0","doc":"","ref":"Rivet.Ident.Factor.html#count!/0"},{"type":"function","title":"Rivet.Ident.Factor.count!/1","doc":"","ref":"Rivet.Ident.Factor.html#count!/1"},{"type":"function","title":"Rivet.Ident.Factor.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Factor.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Factor.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Factor.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Factor.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Factor.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Factor.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Factor.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Factor.create/1","doc":"","ref":"Rivet.Ident.Factor.html#create/1"},{"type":"function","title":"Rivet.Ident.Factor.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Factor.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Factor.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Factor.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Factor.delete/1","doc":"","ref":"Rivet.Ident.Factor.html#delete/1"},{"type":"function","title":"Rivet.Ident.Factor.delete_all/2","doc":"","ref":"Rivet.Ident.Factor.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Factor.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Factor.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Factor.drop_replace/2","doc":"","ref":"Rivet.Ident.Factor.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Factor.exists?/1","doc":"","ref":"Rivet.Ident.Factor.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Factor.full_table_scan/2","doc":"","ref":"Rivet.Ident.Factor.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Factor.hash_password/1","doc":"","ref":"Rivet.Ident.Factor.html#hash_password/1"},{"type":"function","title":"Rivet.Ident.Factor.insert/2","doc":"","ref":"Rivet.Ident.Factor.html#insert/2"},{"type":"function","title":"Rivet.Ident.Factor.latest/2","doc":"","ref":"Rivet.Ident.Factor.html#latest/2"},{"type":"function","title":"Rivet.Ident.Factor.latest!/2","doc":"","ref":"Rivet.Ident.Factor.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Factor.one/2","doc":"","ref":"Rivet.Ident.Factor.html#one/2"},{"type":"function","title":"Rivet.Ident.Factor.one!/2","doc":"","ref":"Rivet.Ident.Factor.html#one!/2"},{"type":"function","title":"Rivet.Ident.Factor.preload/3","doc":"","ref":"Rivet.Ident.Factor.html#preload/3"},{"type":"function","title":"Rivet.Ident.Factor.preload!/3","doc":"","ref":"Rivet.Ident.Factor.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Factor.replace/2","doc":"","ref":"Rivet.Ident.Factor.html#replace/2"},{"type":"function","title":"Rivet.Ident.Factor.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Factor.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Factor.stream/2","doc":"","ref":"Rivet.Ident.Factor.html#stream/2"},{"type":"function","title":"Rivet.Ident.Factor.stream_all!/2","doc":"","ref":"Rivet.Ident.Factor.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Factor.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Factor.html#touch/1"},{"type":"function","title":"Rivet.Ident.Factor.unload/1","doc":"","ref":"Rivet.Ident.Factor.html#unload/1"},{"type":"function","title":"Rivet.Ident.Factor.unload/2","doc":"","ref":"Rivet.Ident.Factor.html#unload/2"},{"type":"function","title":"Rivet.Ident.Factor.update/2","doc":"","ref":"Rivet.Ident.Factor.html#update/2"},{"type":"function","title":"Rivet.Ident.Factor.update!/2","doc":"","ref":"Rivet.Ident.Factor.html#update!/2"},{"type":"function","title":"Rivet.Ident.Factor.update_all/2","doc":"","ref":"Rivet.Ident.Factor.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Factor.update_fill/2","doc":"","ref":"Rivet.Ident.Factor.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Factor.upsert/2","doc":"","ref":"Rivet.Ident.Factor.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Factor.validate/1","doc":"","ref":"Rivet.Ident.Factor.html#validate/1"},{"type":"type","title":"Rivet.Ident.Factor.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Factor.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Factor.id/0","doc":"","ref":"Rivet.Ident.Factor.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Factor.model_p_result/0","doc":"","ref":"Rivet.Ident.Factor.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Factor.t/0","doc":"","ref":"Rivet.Ident.Factor.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Factor.Cache","doc":"","ref":"Rivet.Ident.Factor.Cache.html"},{"type":"function","title":"Rivet.Ident.Factor.Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rivet.Ident.Factor.Cache.html#child_spec/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.clear/0","doc":"Delete everything in the cache.\n\nReturns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.Factor.Cache.html#clear/0"},{"type":"function","title":"Rivet.Ident.Factor.Cache.delete/1","doc":"Delete anything by its key.\n\nReturns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.Factor.Cache.html#delete/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.get_user_factor/1","doc":"Read-through cache for loading user factors from Ident.","ref":"Rivet.Ident.Factor.Cache.html#get_user_factor/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.insert/3","doc":"Store anything for a certain amount of time or forever if no keep alive time specified\n\nReturns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.Factor.Cache.html#insert/3"},{"type":"function","title":"Rivet.Ident.Factor.Cache.lookup/1","doc":"Retrieve anything by its key.\n\nReturns `[{your_stored_tuple}]`.","ref":"Rivet.Ident.Factor.Cache.html#lookup/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.persist/1","doc":"","ref":"Rivet.Ident.Factor.Cache.html#persist/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.purge_cache/0","doc":"","ref":"Rivet.Ident.Factor.Cache.html#purge_cache/0"},{"type":"function","title":"Rivet.Ident.Factor.Cache.size/0","doc":"Obtain the number of elements stored in the cache.\n\nReturns an integer equals or bigger than zero.","ref":"Rivet.Ident.Factor.Cache.html#size/0"},{"type":"function","title":"Rivet.Ident.Factor.Cache.start_link/1","doc":"Start scheduling the works for clearing the cache.\nThis method should be called before performing any operation.\n\nReturns `{:ok, PID}`.","ref":"Rivet.Ident.Factor.Cache.html#start_link/1"},{"type":"function","title":"Rivet.Ident.Factor.Cache.update_user/1","doc":"","ref":"Rivet.Ident.Factor.Cache.html#update_user/1"},{"type":"module","title":"Rivet.Ident.Factor.FedId","doc":"Structure for in-process authentication result contexts, not directly to one user","ref":"Rivet.Ident.Factor.FedId.html"},{"type":"type","title":"Rivet.Ident.Factor.FedId.t/0","doc":"","ref":"Rivet.Ident.Factor.FedId.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Factor.FedId.Email","doc":"","ref":"Rivet.Ident.Factor.FedId.Email.html"},{"type":"type","title":"Rivet.Ident.Factor.FedId.Email.t/0","doc":"","ref":"Rivet.Ident.Factor.FedId.Email.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Factor.FedId.Provider","doc":"","ref":"Rivet.Ident.Factor.FedId.Provider.html"},{"type":"type","title":"Rivet.Ident.Factor.FedId.Provider.t/0","doc":"","ref":"Rivet.Ident.Factor.FedId.Provider.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Factor.FederatedTypes","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.cast/1","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#cast/1"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.dump/1","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#dump/1"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.embed_as/1","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#embed_as/1"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.equal?/2","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#equal?/2"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.load/1","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#load/1"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.type/0","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#type/0"},{"type":"function","title":"Rivet.Ident.Factor.FederatedTypes.valid_value?/1","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#valid_value?/1"},{"type":"type","title":"Rivet.Ident.Factor.FederatedTypes.t/0","doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Factor.Lib","doc":"","ref":"Rivet.Ident.Factor.Lib.html"},{"type":"function","title":"Rivet.Ident.Factor.Lib.all_not_expired!/1","doc":"","ref":"Rivet.Ident.Factor.Lib.html#all_not_expired!/1"},{"type":"function","title":"Rivet.Ident.Factor.Lib.all_not_expired!/2","doc":"","ref":"Rivet.Ident.Factor.Lib.html#all_not_expired!/2"},{"type":"function","title":"Rivet.Ident.Factor.Lib.clean_password_history/2","doc":"","ref":"Rivet.Ident.Factor.Lib.html#clean_password_history/2"},{"type":"function","title":"Rivet.Ident.Factor.Lib.drop_expired/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#drop_expired/0"},{"type":"function","title":"Rivet.Ident.Factor.Lib.get/1","doc":"","ref":"Rivet.Ident.Factor.Lib.html#get/1"},{"type":"function","title":"Rivet.Ident.Factor.Lib.get_user/1","doc":"","ref":"Rivet.Ident.Factor.Lib.html#get_user/1"},{"type":"function","title":"Rivet.Ident.Factor.Lib.preloaded_with/2","doc":"Preload factors for a related model, with criteria, and only unexpired factors\n\n    Ident.Factor.Lib.preloaded_with(model, type)","ref":"Rivet.Ident.Factor.Lib.html#preloaded_with/2"},{"type":"function","title":"Rivet.Ident.Factor.Lib.set_factor/2","doc":"","ref":"Rivet.Ident.Factor.Lib.html#set_factor/2"},{"type":"function","title":"Rivet.Ident.Factor.Lib.set_password/3","doc":"set a password\n\nFuture change:\n\nchange Ident.Factors so there is an archive state, some types when being cleaned\nare archived instead of deleted (such as passwords).\n\nThen Auth.Signin.Local.load_password_factor should filter on !archived","ref":"Rivet.Ident.Factor.Lib.html#set_password/3"},{"type":"function","title":"Rivet.Ident.Factor.Lib.strong_password/1","doc":"iex> strong_password(\"  strong_password(\"boo\")\n{:error, \"Password is not long enough (greater than 8)\"}\niex> strong_password(\"  strong_password(\"KOIJMko09ijm\")\n{:error, \"Password needs special characters (not alphanumeric)\"}\niex> strong_password(\"  strong_password(\" <\")\n{:error, \"Password needs letters\"}","ref":"Rivet.Ident.Factor.Lib.html#strong_password/1"},{"type":"type","title":"Rivet.Ident.Factor.Lib.auth_result/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:auth_result/0"},{"type":"type","title":"Rivet.Ident.Factor.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Factor.Lib.log_msg/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:log_msg/0"},{"type":"type","title":"Rivet.Ident.Factor.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Factor.Lib.str/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:str/0"},{"type":"type","title":"Rivet.Ident.Factor.Lib.usr_msg/0","doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:usr_msg/0"},{"type":"module","title":"Rivet.Ident.Factor.Password.Puid","doc":"Puid.generate/0 is included with the `use` statement below.  It generates 18 random characters.","ref":"Rivet.Ident.Factor.Password.Puid.html"},{"type":"function","title":"Rivet.Ident.Factor.Password.Puid.generate/0","doc":"Generate a `puid`","ref":"Rivet.Ident.Factor.Password.Puid.html#generate/0"},{"type":"function","title":"Rivet.Ident.Factor.Password.Puid.info/0","doc":"`Puid.Info` module info","ref":"Rivet.Ident.Factor.Password.Puid.html#info/0"},{"type":"module","title":"Rivet.Ident.Factor.Password.Puid.Bits","doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html"},{"type":"function","title":"Rivet.Ident.Factor.Password.Puid.Bits.generate/0","doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html#generate/0"},{"type":"function","title":"Rivet.Ident.Factor.Password.Puid.Bits.reset/0","doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html#reset/0"},{"type":"module","title":"Rivet.Ident.Factor.Password.Puid.Encoding","doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Encoding.html"},{"type":"function","title":"Rivet.Ident.Factor.Password.Puid.Encoding.encode/1","doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Encoding.html#encode/1"},{"type":"module","title":"Rivet.Ident.Factor.Password.RandChars","doc":"","ref":"Rivet.Ident.Factor.Password.RandChars.html"},{"type":"function","title":"Rivet.Ident.Factor.Password.RandChars.generate/0","doc":"random/0 generates a 72-character random string.","ref":"Rivet.Ident.Factor.Password.RandChars.html#generate/0"},{"type":"module","title":"Rivet.Ident.Factor.Types","doc":"","ref":"Rivet.Ident.Factor.Types.html"},{"type":"function","title":"Rivet.Ident.Factor.Types.cast/1","doc":"","ref":"Rivet.Ident.Factor.Types.html#cast/1"},{"type":"function","title":"Rivet.Ident.Factor.Types.dump/1","doc":"","ref":"Rivet.Ident.Factor.Types.html#dump/1"},{"type":"function","title":"Rivet.Ident.Factor.Types.embed_as/1","doc":"","ref":"Rivet.Ident.Factor.Types.html#embed_as/1"},{"type":"function","title":"Rivet.Ident.Factor.Types.equal?/2","doc":"","ref":"Rivet.Ident.Factor.Types.html#equal?/2"},{"type":"function","title":"Rivet.Ident.Factor.Types.load/1","doc":"","ref":"Rivet.Ident.Factor.Types.html#load/1"},{"type":"function","title":"Rivet.Ident.Factor.Types.type/0","doc":"","ref":"Rivet.Ident.Factor.Types.html#type/0"},{"type":"function","title":"Rivet.Ident.Factor.Types.valid_value?/1","doc":"","ref":"Rivet.Ident.Factor.Types.html#valid_value?/1"},{"type":"type","title":"Rivet.Ident.Factor.Types.t/0","doc":"","ref":"Rivet.Ident.Factor.Types.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Handle","doc":"Schema for representing and working with a Handle.","ref":"Rivet.Ident.Handle.html"},{"type":"function","title":"Rivet.Ident.Handle.aggregate/2","doc":"","ref":"Rivet.Ident.Handle.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Handle.all/2","doc":"","ref":"Rivet.Ident.Handle.html#all/2"},{"type":"function","title":"Rivet.Ident.Handle.all!/2","doc":"","ref":"Rivet.Ident.Handle.html#all!/2"},{"type":"function","title":"Rivet.Ident.Handle.associate/3","doc":"","ref":"Rivet.Ident.Handle.html#associate/3"},{"type":"function","title":"Rivet.Ident.Handle.build/1","doc":"","ref":"Rivet.Ident.Handle.html#build/1"},{"type":"function","title":"Rivet.Ident.Handle.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Handle.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Handle.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Handle.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Handle.changeset/2","doc":"","ref":"Rivet.Ident.Handle.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Handle.count!/0","doc":"","ref":"Rivet.Ident.Handle.html#count!/0"},{"type":"function","title":"Rivet.Ident.Handle.count!/1","doc":"","ref":"Rivet.Ident.Handle.html#count!/1"},{"type":"function","title":"Rivet.Ident.Handle.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Handle.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Handle.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Handle.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Handle.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Handle.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Handle.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Handle.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Handle.create/1","doc":"","ref":"Rivet.Ident.Handle.html#create/1"},{"type":"function","title":"Rivet.Ident.Handle.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Handle.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Handle.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Handle.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Handle.delete/1","doc":"","ref":"Rivet.Ident.Handle.html#delete/1"},{"type":"function","title":"Rivet.Ident.Handle.delete_all/2","doc":"","ref":"Rivet.Ident.Handle.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Handle.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Handle.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Handle.drop_replace/2","doc":"","ref":"Rivet.Ident.Handle.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Handle.exists?/1","doc":"","ref":"Rivet.Ident.Handle.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Handle.full_table_scan/2","doc":"","ref":"Rivet.Ident.Handle.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Handle.insert/2","doc":"","ref":"Rivet.Ident.Handle.html#insert/2"},{"type":"function","title":"Rivet.Ident.Handle.latest/2","doc":"","ref":"Rivet.Ident.Handle.html#latest/2"},{"type":"function","title":"Rivet.Ident.Handle.latest!/2","doc":"","ref":"Rivet.Ident.Handle.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Handle.one/2","doc":"","ref":"Rivet.Ident.Handle.html#one/2"},{"type":"function","title":"Rivet.Ident.Handle.one!/2","doc":"","ref":"Rivet.Ident.Handle.html#one!/2"},{"type":"function","title":"Rivet.Ident.Handle.preload/3","doc":"","ref":"Rivet.Ident.Handle.html#preload/3"},{"type":"function","title":"Rivet.Ident.Handle.preload!/3","doc":"","ref":"Rivet.Ident.Handle.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Handle.replace/2","doc":"","ref":"Rivet.Ident.Handle.html#replace/2"},{"type":"function","title":"Rivet.Ident.Handle.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Handle.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Handle.stream/2","doc":"","ref":"Rivet.Ident.Handle.html#stream/2"},{"type":"function","title":"Rivet.Ident.Handle.stream_all!/2","doc":"","ref":"Rivet.Ident.Handle.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Handle.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Handle.html#touch/1"},{"type":"function","title":"Rivet.Ident.Handle.unload/1","doc":"","ref":"Rivet.Ident.Handle.html#unload/1"},{"type":"function","title":"Rivet.Ident.Handle.unload/2","doc":"","ref":"Rivet.Ident.Handle.html#unload/2"},{"type":"function","title":"Rivet.Ident.Handle.update/2","doc":"","ref":"Rivet.Ident.Handle.html#update/2"},{"type":"function","title":"Rivet.Ident.Handle.update!/2","doc":"","ref":"Rivet.Ident.Handle.html#update!/2"},{"type":"function","title":"Rivet.Ident.Handle.update_all/2","doc":"","ref":"Rivet.Ident.Handle.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Handle.update_fill/2","doc":"","ref":"Rivet.Ident.Handle.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Handle.upsert/2","doc":"","ref":"Rivet.Ident.Handle.html#upsert/2"},{"type":"type","title":"Rivet.Ident.Handle.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Handle.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Handle.id/0","doc":"","ref":"Rivet.Ident.Handle.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Handle.model_p_result/0","doc":"","ref":"Rivet.Ident.Handle.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Handle.t/0","doc":"","ref":"Rivet.Ident.Handle.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Handle.Lib","doc":"","ref":"Rivet.Ident.Handle.Lib.html"},{"type":"function","title":"Rivet.Ident.Handle.Lib.available/2","doc":"Check if handle is open, return double-error (internal/external msg)","ref":"Rivet.Ident.Handle.Lib.html#available/2"},{"type":"function","title":"Rivet.Ident.Handle.Lib.gen_good_handle/1","doc":"","ref":"Rivet.Ident.Handle.Lib.html#gen_good_handle/1"},{"type":"type","title":"Rivet.Ident.Handle.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Handle.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Handle.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Handle.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.Phone","doc":"","ref":"Rivet.Ident.Phone.html"},{"type":"function","title":"Rivet.Ident.Phone.aggregate/2","doc":"","ref":"Rivet.Ident.Phone.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Phone.all/2","doc":"","ref":"Rivet.Ident.Phone.html#all/2"},{"type":"function","title":"Rivet.Ident.Phone.all!/2","doc":"","ref":"Rivet.Ident.Phone.html#all!/2"},{"type":"function","title":"Rivet.Ident.Phone.associate/3","doc":"","ref":"Rivet.Ident.Phone.html#associate/3"},{"type":"function","title":"Rivet.Ident.Phone.build/1","doc":"","ref":"Rivet.Ident.Phone.html#build/1"},{"type":"function","title":"Rivet.Ident.Phone.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Phone.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Phone.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Phone.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Phone.changeset/2","doc":"","ref":"Rivet.Ident.Phone.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Phone.count!/0","doc":"","ref":"Rivet.Ident.Phone.html#count!/0"},{"type":"function","title":"Rivet.Ident.Phone.count!/1","doc":"","ref":"Rivet.Ident.Phone.html#count!/1"},{"type":"function","title":"Rivet.Ident.Phone.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Phone.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Phone.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Phone.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Phone.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Phone.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Phone.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Phone.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Phone.create/1","doc":"","ref":"Rivet.Ident.Phone.html#create/1"},{"type":"function","title":"Rivet.Ident.Phone.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Phone.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Phone.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Phone.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Phone.delete/1","doc":"","ref":"Rivet.Ident.Phone.html#delete/1"},{"type":"function","title":"Rivet.Ident.Phone.delete_all/2","doc":"","ref":"Rivet.Ident.Phone.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Phone.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Phone.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Phone.drop_replace/2","doc":"","ref":"Rivet.Ident.Phone.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Phone.exists?/1","doc":"","ref":"Rivet.Ident.Phone.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Phone.full_table_scan/2","doc":"","ref":"Rivet.Ident.Phone.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Phone.insert/2","doc":"","ref":"Rivet.Ident.Phone.html#insert/2"},{"type":"function","title":"Rivet.Ident.Phone.latest/2","doc":"","ref":"Rivet.Ident.Phone.html#latest/2"},{"type":"function","title":"Rivet.Ident.Phone.latest!/2","doc":"","ref":"Rivet.Ident.Phone.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Phone.one/2","doc":"","ref":"Rivet.Ident.Phone.html#one/2"},{"type":"function","title":"Rivet.Ident.Phone.one!/2","doc":"","ref":"Rivet.Ident.Phone.html#one!/2"},{"type":"function","title":"Rivet.Ident.Phone.preload/3","doc":"","ref":"Rivet.Ident.Phone.html#preload/3"},{"type":"function","title":"Rivet.Ident.Phone.preload!/3","doc":"","ref":"Rivet.Ident.Phone.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Phone.replace/2","doc":"","ref":"Rivet.Ident.Phone.html#replace/2"},{"type":"function","title":"Rivet.Ident.Phone.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Phone.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Phone.stream/2","doc":"","ref":"Rivet.Ident.Phone.html#stream/2"},{"type":"function","title":"Rivet.Ident.Phone.stream_all!/2","doc":"","ref":"Rivet.Ident.Phone.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Phone.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Phone.html#touch/1"},{"type":"function","title":"Rivet.Ident.Phone.unload/1","doc":"","ref":"Rivet.Ident.Phone.html#unload/1"},{"type":"function","title":"Rivet.Ident.Phone.unload/2","doc":"","ref":"Rivet.Ident.Phone.html#unload/2"},{"type":"function","title":"Rivet.Ident.Phone.update/2","doc":"","ref":"Rivet.Ident.Phone.html#update/2"},{"type":"function","title":"Rivet.Ident.Phone.update!/2","doc":"","ref":"Rivet.Ident.Phone.html#update!/2"},{"type":"function","title":"Rivet.Ident.Phone.update_all/2","doc":"","ref":"Rivet.Ident.Phone.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Phone.update_fill/2","doc":"","ref":"Rivet.Ident.Phone.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Phone.upsert/2","doc":"","ref":"Rivet.Ident.Phone.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Phone.validate/1","doc":"","ref":"Rivet.Ident.Phone.html#validate/1"},{"type":"type","title":"Rivet.Ident.Phone.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Phone.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Phone.id/0","doc":"","ref":"Rivet.Ident.Phone.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Phone.model_p_result/0","doc":"","ref":"Rivet.Ident.Phone.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Phone.t/0","doc":"","ref":"Rivet.Ident.Phone.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Phone.Lib","doc":"","ref":"Rivet.Ident.Phone.Lib.html"},{"type":"type","title":"Rivet.Ident.Phone.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Phone.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Phone.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Phone.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.Role","doc":"","ref":"Rivet.Ident.Role.html"},{"type":"function","title":"Rivet.Ident.Role.aggregate/2","doc":"","ref":"Rivet.Ident.Role.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.Role.all/2","doc":"","ref":"Rivet.Ident.Role.html#all/2"},{"type":"function","title":"Rivet.Ident.Role.all!/2","doc":"","ref":"Rivet.Ident.Role.html#all!/2"},{"type":"function","title":"Rivet.Ident.Role.associate/3","doc":"","ref":"Rivet.Ident.Role.html#associate/3"},{"type":"function","title":"Rivet.Ident.Role.build/1","doc":"","ref":"Rivet.Ident.Role.html#build/1"},{"type":"function","title":"Rivet.Ident.Role.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Role.html#change_post/2"},{"type":"function","title":"Rivet.Ident.Role.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Role.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.Role.changeset/2","doc":"","ref":"Rivet.Ident.Role.html#changeset/2"},{"type":"function","title":"Rivet.Ident.Role.count!/0","doc":"","ref":"Rivet.Ident.Role.html#count!/0"},{"type":"function","title":"Rivet.Ident.Role.count!/1","doc":"","ref":"Rivet.Ident.Role.html#count!/1"},{"type":"function","title":"Rivet.Ident.Role.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.Role.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.Role.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.Role.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.Role.count_by_updated!/0","doc":"","ref":"Rivet.Ident.Role.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.Role.count_by_updated!/1","doc":"","ref":"Rivet.Ident.Role.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.Role.create/1","doc":"","ref":"Rivet.Ident.Role.html#create/1"},{"type":"function","title":"Rivet.Ident.Role.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.Role.html#create_post/2"},{"type":"function","title":"Rivet.Ident.Role.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Role.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.Role.delete/1","doc":"","ref":"Rivet.Ident.Role.html#delete/1"},{"type":"function","title":"Rivet.Ident.Role.delete_all/2","doc":"","ref":"Rivet.Ident.Role.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.Role.delete_all_ids/2","doc":"","ref":"Rivet.Ident.Role.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.Role.drop_replace/2","doc":"","ref":"Rivet.Ident.Role.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.Role.exists?/1","doc":"","ref":"Rivet.Ident.Role.html#exists?/1"},{"type":"function","title":"Rivet.Ident.Role.full_table_scan/2","doc":"","ref":"Rivet.Ident.Role.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.Role.insert/2","doc":"","ref":"Rivet.Ident.Role.html#insert/2"},{"type":"function","title":"Rivet.Ident.Role.latest/2","doc":"","ref":"Rivet.Ident.Role.html#latest/2"},{"type":"function","title":"Rivet.Ident.Role.latest!/2","doc":"","ref":"Rivet.Ident.Role.html#latest!/2"},{"type":"function","title":"Rivet.Ident.Role.one/2","doc":"","ref":"Rivet.Ident.Role.html#one/2"},{"type":"function","title":"Rivet.Ident.Role.one!/2","doc":"","ref":"Rivet.Ident.Role.html#one!/2"},{"type":"function","title":"Rivet.Ident.Role.preload/3","doc":"","ref":"Rivet.Ident.Role.html#preload/3"},{"type":"function","title":"Rivet.Ident.Role.preload!/3","doc":"","ref":"Rivet.Ident.Role.html#preload!/3"},{"type":"function","title":"Rivet.Ident.Role.replace/2","doc":"","ref":"Rivet.Ident.Role.html#replace/2"},{"type":"function","title":"Rivet.Ident.Role.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Role.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.Role.stream/2","doc":"","ref":"Rivet.Ident.Role.html#stream/2"},{"type":"function","title":"Rivet.Ident.Role.stream_all!/2","doc":"","ref":"Rivet.Ident.Role.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.Role.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.Role.html#touch/1"},{"type":"function","title":"Rivet.Ident.Role.unload/1","doc":"","ref":"Rivet.Ident.Role.html#unload/1"},{"type":"function","title":"Rivet.Ident.Role.unload/2","doc":"","ref":"Rivet.Ident.Role.html#unload/2"},{"type":"function","title":"Rivet.Ident.Role.update/2","doc":"","ref":"Rivet.Ident.Role.html#update/2"},{"type":"function","title":"Rivet.Ident.Role.update!/2","doc":"","ref":"Rivet.Ident.Role.html#update!/2"},{"type":"function","title":"Rivet.Ident.Role.update_all/2","doc":"","ref":"Rivet.Ident.Role.html#update_all/2"},{"type":"function","title":"Rivet.Ident.Role.update_fill/2","doc":"","ref":"Rivet.Ident.Role.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.Role.upsert/2","doc":"","ref":"Rivet.Ident.Role.html#upsert/2"},{"type":"function","title":"Rivet.Ident.Role.validate/1","doc":"","ref":"Rivet.Ident.Role.html#validate/1"},{"type":"type","title":"Rivet.Ident.Role.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Role.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Role.id/0","doc":"","ref":"Rivet.Ident.Role.html#t:id/0"},{"type":"type","title":"Rivet.Ident.Role.model_p_result/0","doc":"","ref":"Rivet.Ident.Role.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.Role.t/0","doc":"","ref":"Rivet.Ident.Role.html#t:t/0"},{"type":"module","title":"Rivet.Ident.Role.Cache","doc":"","ref":"Rivet.Ident.Role.Cache.html"},{"type":"function","title":"Rivet.Ident.Role.Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rivet.Ident.Role.Cache.html#child_spec/1"},{"type":"function","title":"Rivet.Ident.Role.Cache.clear/0","doc":"Delete everything in the cache.\n\nReturns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.Role.Cache.html#clear/0"},{"type":"function","title":"Rivet.Ident.Role.Cache.delete/1","doc":"Delete anything by its key.\n\nReturns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.Role.Cache.html#delete/1"},{"type":"function","title":"Rivet.Ident.Role.Cache.insert/3","doc":"Store anything for a certain amount of time or forever if no keep alive time specified\n\nReturns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.Role.Cache.html#insert/3"},{"type":"function","title":"Rivet.Ident.Role.Cache.lookup/1","doc":"Retrieve anything by its key.\n\nReturns `[{your_stored_tuple}]`.","ref":"Rivet.Ident.Role.Cache.html#lookup/1"},{"type":"function","title":"Rivet.Ident.Role.Cache.purge_cache/0","doc":"","ref":"Rivet.Ident.Role.Cache.html#purge_cache/0"},{"type":"function","title":"Rivet.Ident.Role.Cache.size/0","doc":"Obtain the number of elements stored in the cache.\n\nReturns an integer equals or bigger than zero.","ref":"Rivet.Ident.Role.Cache.html#size/0"},{"type":"function","title":"Rivet.Ident.Role.Cache.start_link/1","doc":"Start scheduling the works for clearing the cache.\nThis method should be called before performing any operation.\n\nReturns `{:ok, PID}`.","ref":"Rivet.Ident.Role.Cache.html#start_link/1"},{"type":"module","title":"Rivet.Ident.Role.Lib","doc":"","ref":"Rivet.Ident.Role.Lib.html"},{"type":"type","title":"Rivet.Ident.Role.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.Role.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.Role.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.Role.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.RoleMap","doc":"Schema for representing and working with a Ident.RoleMap.","ref":"Rivet.Ident.RoleMap.html"},{"type":"function","title":"Rivet.Ident.RoleMap.aggregate/2","doc":"","ref":"Rivet.Ident.RoleMap.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.RoleMap.all/2","doc":"","ref":"Rivet.Ident.RoleMap.html#all/2"},{"type":"function","title":"Rivet.Ident.RoleMap.all!/2","doc":"","ref":"Rivet.Ident.RoleMap.html#all!/2"},{"type":"function","title":"Rivet.Ident.RoleMap.associate/3","doc":"","ref":"Rivet.Ident.RoleMap.html#associate/3"},{"type":"function","title":"Rivet.Ident.RoleMap.build/1","doc":"","ref":"Rivet.Ident.RoleMap.html#build/1"},{"type":"function","title":"Rivet.Ident.RoleMap.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.RoleMap.html#change_post/2"},{"type":"function","title":"Rivet.Ident.RoleMap.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.RoleMap.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.RoleMap.changeset/2","doc":"","ref":"Rivet.Ident.RoleMap.html#changeset/2"},{"type":"function","title":"Rivet.Ident.RoleMap.count!/0","doc":"","ref":"Rivet.Ident.RoleMap.html#count!/0"},{"type":"function","title":"Rivet.Ident.RoleMap.count!/1","doc":"","ref":"Rivet.Ident.RoleMap.html#count!/1"},{"type":"function","title":"Rivet.Ident.RoleMap.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.RoleMap.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.RoleMap.count_by_updated!/0","doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.RoleMap.count_by_updated!/1","doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.RoleMap.create/1","doc":"","ref":"Rivet.Ident.RoleMap.html#create/1"},{"type":"function","title":"Rivet.Ident.RoleMap.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.RoleMap.html#create_post/2"},{"type":"function","title":"Rivet.Ident.RoleMap.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.RoleMap.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.RoleMap.delete/1","doc":"","ref":"Rivet.Ident.RoleMap.html#delete/1"},{"type":"function","title":"Rivet.Ident.RoleMap.delete_all/2","doc":"","ref":"Rivet.Ident.RoleMap.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.RoleMap.delete_all_ids/2","doc":"","ref":"Rivet.Ident.RoleMap.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.RoleMap.drop_replace/2","doc":"","ref":"Rivet.Ident.RoleMap.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.RoleMap.exists?/1","doc":"","ref":"Rivet.Ident.RoleMap.html#exists?/1"},{"type":"function","title":"Rivet.Ident.RoleMap.full_table_scan/2","doc":"","ref":"Rivet.Ident.RoleMap.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.RoleMap.insert/2","doc":"","ref":"Rivet.Ident.RoleMap.html#insert/2"},{"type":"function","title":"Rivet.Ident.RoleMap.latest/2","doc":"","ref":"Rivet.Ident.RoleMap.html#latest/2"},{"type":"function","title":"Rivet.Ident.RoleMap.latest!/2","doc":"","ref":"Rivet.Ident.RoleMap.html#latest!/2"},{"type":"function","title":"Rivet.Ident.RoleMap.one/2","doc":"","ref":"Rivet.Ident.RoleMap.html#one/2"},{"type":"function","title":"Rivet.Ident.RoleMap.one!/2","doc":"","ref":"Rivet.Ident.RoleMap.html#one!/2"},{"type":"function","title":"Rivet.Ident.RoleMap.preload/3","doc":"","ref":"Rivet.Ident.RoleMap.html#preload/3"},{"type":"function","title":"Rivet.Ident.RoleMap.preload!/3","doc":"","ref":"Rivet.Ident.RoleMap.html#preload!/3"},{"type":"function","title":"Rivet.Ident.RoleMap.replace/2","doc":"","ref":"Rivet.Ident.RoleMap.html#replace/2"},{"type":"function","title":"Rivet.Ident.RoleMap.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.RoleMap.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.RoleMap.stream/2","doc":"","ref":"Rivet.Ident.RoleMap.html#stream/2"},{"type":"function","title":"Rivet.Ident.RoleMap.stream_all!/2","doc":"","ref":"Rivet.Ident.RoleMap.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.RoleMap.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.RoleMap.html#touch/1"},{"type":"function","title":"Rivet.Ident.RoleMap.unload/1","doc":"","ref":"Rivet.Ident.RoleMap.html#unload/1"},{"type":"function","title":"Rivet.Ident.RoleMap.unload/2","doc":"","ref":"Rivet.Ident.RoleMap.html#unload/2"},{"type":"function","title":"Rivet.Ident.RoleMap.update/2","doc":"","ref":"Rivet.Ident.RoleMap.html#update/2"},{"type":"function","title":"Rivet.Ident.RoleMap.update!/2","doc":"","ref":"Rivet.Ident.RoleMap.html#update!/2"},{"type":"function","title":"Rivet.Ident.RoleMap.update_all/2","doc":"","ref":"Rivet.Ident.RoleMap.html#update_all/2"},{"type":"function","title":"Rivet.Ident.RoleMap.update_fill/2","doc":"","ref":"Rivet.Ident.RoleMap.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.RoleMap.upsert/2","doc":"","ref":"Rivet.Ident.RoleMap.html#upsert/2"},{"type":"function","title":"Rivet.Ident.RoleMap.validate/1","doc":"","ref":"Rivet.Ident.RoleMap.html#validate/1"},{"type":"type","title":"Rivet.Ident.RoleMap.ecto_p_result/0","doc":"","ref":"Rivet.Ident.RoleMap.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.RoleMap.id/0","doc":"","ref":"Rivet.Ident.RoleMap.html#t:id/0"},{"type":"type","title":"Rivet.Ident.RoleMap.model_p_result/0","doc":"","ref":"Rivet.Ident.RoleMap.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.RoleMap.t/0","doc":"","ref":"Rivet.Ident.RoleMap.html#t:t/0"},{"type":"module","title":"Rivet.Ident.RoleMap.Lib","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html"},{"type":"function","title":"Rivet.Ident.RoleMap.Lib.get_actions/1","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#get_actions/1"},{"type":"function","title":"Rivet.Ident.RoleMap.Lib.get_actions/3","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#get_actions/3"},{"type":"function","title":"Rivet.Ident.RoleMap.Lib.map_actions/1","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#map_actions/1"},{"type":"type","title":"Rivet.Ident.RoleMap.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.RoleMap.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.User","doc":"Schema for representing and working with a Ident.User.","ref":"Rivet.Ident.User.html"},{"type":"function","title":"Rivet.Ident.User.aggregate/2","doc":"","ref":"Rivet.Ident.User.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.User.all/2","doc":"","ref":"Rivet.Ident.User.html#all/2"},{"type":"function","title":"Rivet.Ident.User.all!/2","doc":"","ref":"Rivet.Ident.User.html#all!/2"},{"type":"function","title":"Rivet.Ident.User.associate/3","doc":"","ref":"Rivet.Ident.User.html#associate/3"},{"type":"function","title":"Rivet.Ident.User.build/1","doc":"","ref":"Rivet.Ident.User.html#build/1"},{"type":"function","title":"Rivet.Ident.User.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.User.html#change_post/2"},{"type":"function","title":"Rivet.Ident.User.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.User.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.User.changeset/2","doc":"","ref":"Rivet.Ident.User.html#changeset/2"},{"type":"function","title":"Rivet.Ident.User.count!/0","doc":"","ref":"Rivet.Ident.User.html#count!/0"},{"type":"function","title":"Rivet.Ident.User.count!/1","doc":"","ref":"Rivet.Ident.User.html#count!/1"},{"type":"function","title":"Rivet.Ident.User.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.User.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.User.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.User.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.User.count_by_updated!/0","doc":"","ref":"Rivet.Ident.User.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.User.count_by_updated!/1","doc":"","ref":"Rivet.Ident.User.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.User.create/1","doc":"","ref":"Rivet.Ident.User.html#create/1"},{"type":"function","title":"Rivet.Ident.User.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.User.html#create_post/2"},{"type":"function","title":"Rivet.Ident.User.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.User.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.User.delete/1","doc":"","ref":"Rivet.Ident.User.html#delete/1"},{"type":"function","title":"Rivet.Ident.User.delete_all/2","doc":"","ref":"Rivet.Ident.User.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.User.delete_all_ids/2","doc":"","ref":"Rivet.Ident.User.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.User.drop_replace/2","doc":"","ref":"Rivet.Ident.User.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.User.enabled?/1","doc":"","ref":"Rivet.Ident.User.html#enabled?/1"},{"type":"function","title":"Rivet.Ident.User.exists?/1","doc":"","ref":"Rivet.Ident.User.html#exists?/1"},{"type":"function","title":"Rivet.Ident.User.full_table_scan/2","doc":"","ref":"Rivet.Ident.User.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.User.insert/2","doc":"","ref":"Rivet.Ident.User.html#insert/2"},{"type":"function","title":"Rivet.Ident.User.latest/2","doc":"","ref":"Rivet.Ident.User.html#latest/2"},{"type":"function","title":"Rivet.Ident.User.latest!/2","doc":"","ref":"Rivet.Ident.User.html#latest!/2"},{"type":"function","title":"Rivet.Ident.User.one/2","doc":"","ref":"Rivet.Ident.User.html#one/2"},{"type":"function","title":"Rivet.Ident.User.one!/2","doc":"","ref":"Rivet.Ident.User.html#one!/2"},{"type":"function","title":"Rivet.Ident.User.preload/3","doc":"","ref":"Rivet.Ident.User.html#preload/3"},{"type":"function","title":"Rivet.Ident.User.preload!/3","doc":"","ref":"Rivet.Ident.User.html#preload!/3"},{"type":"function","title":"Rivet.Ident.User.replace/2","doc":"","ref":"Rivet.Ident.User.html#replace/2"},{"type":"function","title":"Rivet.Ident.User.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.User.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.User.stream/2","doc":"","ref":"Rivet.Ident.User.html#stream/2"},{"type":"function","title":"Rivet.Ident.User.stream_all!/2","doc":"","ref":"Rivet.Ident.User.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.User.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.User.html#touch/1"},{"type":"function","title":"Rivet.Ident.User.unload/1","doc":"","ref":"Rivet.Ident.User.html#unload/1"},{"type":"function","title":"Rivet.Ident.User.unload/2","doc":"","ref":"Rivet.Ident.User.html#unload/2"},{"type":"function","title":"Rivet.Ident.User.update/2","doc":"","ref":"Rivet.Ident.User.html#update/2"},{"type":"function","title":"Rivet.Ident.User.update!/2","doc":"","ref":"Rivet.Ident.User.html#update!/2"},{"type":"function","title":"Rivet.Ident.User.update_all/2","doc":"","ref":"Rivet.Ident.User.html#update_all/2"},{"type":"function","title":"Rivet.Ident.User.update_fill/2","doc":"","ref":"Rivet.Ident.User.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.User.upsert/2","doc":"","ref":"Rivet.Ident.User.html#upsert/2"},{"type":"function","title":"Rivet.Ident.User.validate/1","doc":"","ref":"Rivet.Ident.User.html#validate/1"},{"type":"type","title":"Rivet.Ident.User.ecto_p_result/0","doc":"","ref":"Rivet.Ident.User.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.User.id/0","doc":"","ref":"Rivet.Ident.User.html#t:id/0"},{"type":"type","title":"Rivet.Ident.User.model_p_result/0","doc":"","ref":"Rivet.Ident.User.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.User.t/0","doc":"","ref":"Rivet.Ident.User.html#t:t/0"},{"type":"module","title":"Rivet.Ident.User.Cache","doc":"Used by websockets token authentication.  Very short term cache to efficiently\nload ~30 websockets all at once for a single dashboard.","ref":"Rivet.Ident.User.Cache.html"},{"type":"function","title":"Rivet.Ident.User.Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rivet.Ident.User.Cache.html#child_spec/1"},{"type":"function","title":"Rivet.Ident.User.Cache.clear/0","doc":"Delete everything in the cache.\n\nReturns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.User.Cache.html#clear/0"},{"type":"function","title":"Rivet.Ident.User.Cache.delete/1","doc":"Delete anything by its key.\n\nReturns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.User.Cache.html#delete/1"},{"type":"function","title":"Rivet.Ident.User.Cache.get_user/1","doc":"","ref":"Rivet.Ident.User.Cache.html#get_user/1"},{"type":"function","title":"Rivet.Ident.User.Cache.insert/3","doc":"Store anything for a certain amount of time or forever if no keep alive time specified\n\nReturns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.User.Cache.html#insert/3"},{"type":"function","title":"Rivet.Ident.User.Cache.lookup/1","doc":"Retrieve anything by its key.\n\nReturns `[{your_stored_tuple}]`.","ref":"Rivet.Ident.User.Cache.html#lookup/1"},{"type":"function","title":"Rivet.Ident.User.Cache.persist/1","doc":"","ref":"Rivet.Ident.User.Cache.html#persist/1"},{"type":"function","title":"Rivet.Ident.User.Cache.purge_cache/0","doc":"","ref":"Rivet.Ident.User.Cache.html#purge_cache/0"},{"type":"function","title":"Rivet.Ident.User.Cache.size/0","doc":"Obtain the number of elements stored in the cache.\n\nReturns an integer equals or bigger than zero.","ref":"Rivet.Ident.User.Cache.html#size/0"},{"type":"function","title":"Rivet.Ident.User.Cache.start_link/1","doc":"Start scheduling the works for clearing the cache.\nThis method should be called before performing any operation.\n\nReturns `{:ok, PID}`.","ref":"Rivet.Ident.User.Cache.html#start_link/1"},{"type":"module","title":"Rivet.Ident.User.Lib","doc":"","ref":"Rivet.Ident.User.Lib.html"},{"type":"function","title":"Rivet.Ident.User.Lib.add_email/3","doc":"","ref":"Rivet.Ident.User.Lib.html#add_email/3"},{"type":"function","title":"Rivet.Ident.User.Lib.add_phone/2","doc":"","ref":"Rivet.Ident.User.Lib.html#add_phone/2"},{"type":"function","title":"Rivet.Ident.User.Lib.all_since/1","doc":"","ref":"Rivet.Ident.User.Lib.html#all_since/1"},{"type":"function","title":"Rivet.Ident.User.Lib.check_authz/2","doc":"","ref":"Rivet.Ident.User.Lib.html#check_authz/2"},{"type":"function","title":"Rivet.Ident.User.Lib.check_user_status/1","doc":"","ref":"Rivet.Ident.User.Lib.html#check_user_status/1"},{"type":"function","title":"Rivet.Ident.User.Lib.get_authz/1","doc":"Bring in the list of authorized actions onto the user object (into :authz)\n\nOnly load once, if authz is nil","ref":"Rivet.Ident.User.Lib.html#get_authz/1"},{"type":"function","title":"Rivet.Ident.User.Lib.get_user/2","doc":"iex> get_user(\"asdf\")\n{:error, :not_found}\n\niex> get_user(\"A73DD874-A724-494F-B9E2-2042A4383144\")\n{:error, :not_found}\n\niex> handle = insert(:ident_handle)\n...> {:ok, u} = get_user(handle.user_id)\n...> u.id\nhandle.user_id\n\niex> handle = insert(:ident_handle)\n...> {:ok, u} = get_user(handle.handle, [:handle])\n...> u.id\nhandle.user_id","ref":"Rivet.Ident.User.Lib.html#get_user/2"},{"type":"function","title":"Rivet.Ident.User.Lib.get_user_by_handle/2","doc":"","ref":"Rivet.Ident.User.Lib.html#get_user_by_handle/2"},{"type":"function","title":"Rivet.Ident.User.Lib.has_other_admin?/2","doc":"","ref":"Rivet.Ident.User.Lib.html#has_other_admin?/2"},{"type":"function","title":"Rivet.Ident.User.Lib.search/2","doc":"","ref":"Rivet.Ident.User.Lib.html#search/2"},{"type":"function","title":"Rivet.Ident.User.Lib.search_name!/1","doc":"","ref":"Rivet.Ident.User.Lib.html#search_name!/1"},{"type":"function","title":"Rivet.Ident.User.Lib.user_seen/1","doc":"","ref":"Rivet.Ident.User.Lib.html#user_seen/1"},{"type":"function","title":"Rivet.Ident.User.Lib.with_user/3","doc":"Helper function which accepts either user_id or user, and calls the passed\nfunction with the user model loaded including any preloads.  Send preloads\nas [] if none are desired.","ref":"Rivet.Ident.User.Lib.html#with_user/3"},{"type":"type","title":"Rivet.Ident.User.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.User.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.User.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.User.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.User.Lib.Signup","doc":"","ref":"Rivet.Ident.User.Lib.Signup.html"},{"type":"function","title":"Rivet.Ident.User.Lib.Signup.add_email/3","doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#add_email/3"},{"type":"function","title":"Rivet.Ident.User.Lib.Signup.add_phone/2","doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#add_phone/2"},{"type":"function","title":"Rivet.Ident.User.Lib.Signup.only_identity/1","doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#only_identity/1"},{"type":"function","title":"Rivet.Ident.User.Lib.Signup.signup/1","doc":"SignUp pipeline","ref":"Rivet.Ident.User.Lib.Signup.html#signup/1"},{"type":"module","title":"Rivet.Ident.User.Lib.Update","doc":"Making changes to a user (administratively or as the user).\n\nSee UsersUpdate.update @spec for details on args.  Explains for said args:\n\n- `user_changes` map is variable, in that it's keys may vary based on the input\n  args sent into GraphQL updatePerson() mutation\n- `caller_authz` is the level of authorization for the caller, which changes\n  what updates are allowed.\n- `target_user` is optional, if nil the user should be created, if exists then\n  it's an update for that user\n\nExample (create):\n\n  ```elixir\n  ==> Rivet.Ident.UsersUpdate.update(%{\n      action: :upsert,\n      user: %{name: \"The Doctor\"},\n      email: %{email: \"who@tardis.com\"}\n    }, :admin)\n  {:ok, %User{}, %{\"password\": \"R^EkW)aBY9G9\", \"passwordExp\": 1649947803}}\n  ```\n  Rivet.Ident.UsersUpdate.update(%{ action: :upsert, user: %{name: \"The Doctor\"}, email: %{email: \"who@tardis.com\"} }, :admin)\n\n  Example — update a user's name as the user\n\n  ```elixir\n  ==> Rivet.Ident.UsersUpdate.update(%{\n    action: :upsert,\n    user: %{name: \"Who\"},\n  }, :user, %User{...})\n  {:ok, %User{}, %{}}\n  ```\n\n  Example — remove a phone\n\n  ```elixir\n  ==> Rivet.Ident.UsersUpdate.update(%{\n    action: :remove,\n    phone: %{id: \"2342343-...-33\"},\n  }, :user, %User{...})\n  {:ok, %User{}, %{}}\n  ```","ref":"Rivet.Ident.User.Lib.Update.html"},{"type":"function","title":"Rivet.Ident.User.Lib.Update.preflight_user_create/1","doc":"","ref":"Rivet.Ident.User.Lib.Update.html#preflight_user_create/1"},{"type":"function","title":"Rivet.Ident.User.Lib.Update.update/3","doc":"","ref":"Rivet.Ident.User.Lib.Update.html#update/3"},{"type":"module","title":"Rivet.Ident.User.Notify.FailedChange","doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html"},{"type":"function","title":"Rivet.Ident.User.Notify.FailedChange.eval/3","doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html#eval/3"},{"type":"function","title":"Rivet.Ident.User.Notify.FailedChange.load_and_eval/2","doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html#load_and_eval/2"},{"type":"module","title":"Rivet.Ident.User.Notify.PasswordChanged","doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordChanged.eval/3","doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#eval/3"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordChanged.load_and_eval/2","doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#load_and_eval/2"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordChanged.send/1","doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#send/1"},{"type":"module","title":"Rivet.Ident.User.Notify.PasswordReset","doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordReset.eval/3","doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#eval/3"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordReset.load_and_eval/2","doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#load_and_eval/2"},{"type":"function","title":"Rivet.Ident.User.Notify.PasswordReset.send/3","doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#send/3"},{"type":"module","title":"Rivet.Ident.User.Notify.Verification","doc":"","ref":"Rivet.Ident.User.Notify.Verification.html"},{"type":"function","title":"Rivet.Ident.User.Notify.Verification.eval/3","doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#eval/3"},{"type":"function","title":"Rivet.Ident.User.Notify.Verification.load_and_eval/2","doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#load_and_eval/2"},{"type":"function","title":"Rivet.Ident.User.Notify.Verification.send/1","doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#send/1"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.generate/0","doc":"Generate random password","ref":"Rivet.Ident.User.PasswordGenerator.html#generate/0"},{"type":"function","title":"Example - Rivet.Ident.User.PasswordGenerator.generate/0","doc":"defmodule(Passwd, do: use(RandomPassword, alpha: 16, decimal: 4, symbol: 2))\n\n    Passwd.generate()\n    \"vwt8FauEN+spr5{m1Rhso7\"","ref":"Rivet.Ident.User.PasswordGenerator.html#generate/0-example"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.info/0","doc":"`RandomPassword` generated module info.","ref":"Rivet.Ident.User.PasswordGenerator.html#info/0"},{"type":"function","title":"Example - Rivet.Ident.User.PasswordGenerator.info/0","doc":"defmodule(Password, do: use(RandomPassword, alpha: 16, decimal: 2, symbol: 1))\n\n    Password.info()\n        %RandomPassword.Info{\n          alpha: 16,\n          decimal: 2,\n          entropy_bits: 102.66,\n          symbol: 1,\n          symbols: \"!#$%&()*+,-./:;<=>?@[]^_{|}~\"\n        }","ref":"Rivet.Ident.User.PasswordGenerator.html#info/0-example"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Alpha","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Alpha.generate/0","doc":"Generate a `puid`","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Alpha.info/0","doc":"`Puid.Info` module info","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html#info/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.generate/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.reset/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html#reset/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.encode/1","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.html#encode/1"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Decimal","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Decimal.generate/0","doc":"Generate a `puid`","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Decimal.info/0","doc":"`Puid.Info` module info","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html#info/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.generate/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.reset/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html#reset/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.encode/1","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.html#encode/1"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Empty","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Empty.generate/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Empty.info/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html#info/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Symbol","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Symbol.generate/0","doc":"Generate a `puid`","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Symbol.info/0","doc":"`Puid.Info` module info","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html#info/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.generate/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html#generate/0"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.reset/0","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html#reset/0"},{"type":"module","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.html"},{"type":"function","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.encode/1","doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.html#encode/1"},{"type":"module","title":"Rivet.Ident.User.Types","doc":"","ref":"Rivet.Ident.User.Types.html"},{"type":"function","title":"Rivet.Ident.User.Types.cast/1","doc":"","ref":"Rivet.Ident.User.Types.html#cast/1"},{"type":"function","title":"Rivet.Ident.User.Types.dump/1","doc":"","ref":"Rivet.Ident.User.Types.html#dump/1"},{"type":"function","title":"Rivet.Ident.User.Types.embed_as/1","doc":"","ref":"Rivet.Ident.User.Types.html#embed_as/1"},{"type":"function","title":"Rivet.Ident.User.Types.equal?/2","doc":"","ref":"Rivet.Ident.User.Types.html#equal?/2"},{"type":"function","title":"Rivet.Ident.User.Types.load/1","doc":"","ref":"Rivet.Ident.User.Types.html#load/1"},{"type":"function","title":"Rivet.Ident.User.Types.type/0","doc":"","ref":"Rivet.Ident.User.Types.html#type/0"},{"type":"function","title":"Rivet.Ident.User.Types.valid_value?/1","doc":"","ref":"Rivet.Ident.User.Types.html#valid_value?/1"},{"type":"type","title":"Rivet.Ident.User.Types.t/0","doc":"","ref":"Rivet.Ident.User.Types.html#t:t/0"},{"type":"module","title":"Rivet.Ident.UserCode","doc":"Schema for representing and working with a Ident.UserCode.","ref":"Rivet.Ident.UserCode.html"},{"type":"function","title":"Rivet.Ident.UserCode.aggregate/2","doc":"","ref":"Rivet.Ident.UserCode.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.UserCode.all/2","doc":"","ref":"Rivet.Ident.UserCode.html#all/2"},{"type":"function","title":"Rivet.Ident.UserCode.all!/2","doc":"","ref":"Rivet.Ident.UserCode.html#all!/2"},{"type":"function","title":"Rivet.Ident.UserCode.associate/3","doc":"","ref":"Rivet.Ident.UserCode.html#associate/3"},{"type":"function","title":"Rivet.Ident.UserCode.build/1","doc":"","ref":"Rivet.Ident.UserCode.html#build/1"},{"type":"function","title":"Rivet.Ident.UserCode.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserCode.html#change_post/2"},{"type":"function","title":"Rivet.Ident.UserCode.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserCode.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.UserCode.changeset/2","doc":"","ref":"Rivet.Ident.UserCode.html#changeset/2"},{"type":"function","title":"Rivet.Ident.UserCode.count!/0","doc":"","ref":"Rivet.Ident.UserCode.html#count!/0"},{"type":"function","title":"Rivet.Ident.UserCode.count!/1","doc":"","ref":"Rivet.Ident.UserCode.html#count!/1"},{"type":"function","title":"Rivet.Ident.UserCode.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.UserCode.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.UserCode.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.UserCode.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.UserCode.count_by_updated!/0","doc":"","ref":"Rivet.Ident.UserCode.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.UserCode.count_by_updated!/1","doc":"","ref":"Rivet.Ident.UserCode.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.UserCode.create/1","doc":"","ref":"Rivet.Ident.UserCode.html#create/1"},{"type":"function","title":"Rivet.Ident.UserCode.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserCode.html#create_post/2"},{"type":"function","title":"Rivet.Ident.UserCode.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserCode.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.UserCode.delete/1","doc":"","ref":"Rivet.Ident.UserCode.html#delete/1"},{"type":"function","title":"Rivet.Ident.UserCode.delete_all/2","doc":"","ref":"Rivet.Ident.UserCode.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.UserCode.delete_all_ids/2","doc":"","ref":"Rivet.Ident.UserCode.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.UserCode.drop_replace/2","doc":"","ref":"Rivet.Ident.UserCode.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.UserCode.exists?/1","doc":"","ref":"Rivet.Ident.UserCode.html#exists?/1"},{"type":"function","title":"Rivet.Ident.UserCode.full_table_scan/2","doc":"","ref":"Rivet.Ident.UserCode.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.UserCode.insert/2","doc":"","ref":"Rivet.Ident.UserCode.html#insert/2"},{"type":"function","title":"Rivet.Ident.UserCode.latest/2","doc":"","ref":"Rivet.Ident.UserCode.html#latest/2"},{"type":"function","title":"Rivet.Ident.UserCode.latest!/2","doc":"","ref":"Rivet.Ident.UserCode.html#latest!/2"},{"type":"function","title":"Rivet.Ident.UserCode.one/2","doc":"","ref":"Rivet.Ident.UserCode.html#one/2"},{"type":"function","title":"Rivet.Ident.UserCode.one!/2","doc":"","ref":"Rivet.Ident.UserCode.html#one!/2"},{"type":"function","title":"Rivet.Ident.UserCode.preload/3","doc":"","ref":"Rivet.Ident.UserCode.html#preload/3"},{"type":"function","title":"Rivet.Ident.UserCode.preload!/3","doc":"","ref":"Rivet.Ident.UserCode.html#preload!/3"},{"type":"function","title":"Rivet.Ident.UserCode.replace/2","doc":"","ref":"Rivet.Ident.UserCode.html#replace/2"},{"type":"function","title":"Rivet.Ident.UserCode.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserCode.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.UserCode.stream/2","doc":"","ref":"Rivet.Ident.UserCode.html#stream/2"},{"type":"function","title":"Rivet.Ident.UserCode.stream_all!/2","doc":"","ref":"Rivet.Ident.UserCode.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.UserCode.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.UserCode.html#touch/1"},{"type":"function","title":"Rivet.Ident.UserCode.unload/1","doc":"","ref":"Rivet.Ident.UserCode.html#unload/1"},{"type":"function","title":"Rivet.Ident.UserCode.unload/2","doc":"","ref":"Rivet.Ident.UserCode.html#unload/2"},{"type":"function","title":"Rivet.Ident.UserCode.update/2","doc":"","ref":"Rivet.Ident.UserCode.html#update/2"},{"type":"function","title":"Rivet.Ident.UserCode.update!/2","doc":"","ref":"Rivet.Ident.UserCode.html#update!/2"},{"type":"function","title":"Rivet.Ident.UserCode.update_all/2","doc":"","ref":"Rivet.Ident.UserCode.html#update_all/2"},{"type":"function","title":"Rivet.Ident.UserCode.update_fill/2","doc":"","ref":"Rivet.Ident.UserCode.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.UserCode.upsert/2","doc":"","ref":"Rivet.Ident.UserCode.html#upsert/2"},{"type":"function","title":"Rivet.Ident.UserCode.validate/1","doc":"","ref":"Rivet.Ident.UserCode.html#validate/1"},{"type":"type","title":"Rivet.Ident.UserCode.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserCode.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserCode.id/0","doc":"","ref":"Rivet.Ident.UserCode.html#t:id/0"},{"type":"type","title":"Rivet.Ident.UserCode.model_p_result/0","doc":"","ref":"Rivet.Ident.UserCode.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.UserCode.t/0","doc":"","ref":"Rivet.Ident.UserCode.html#t:t/0"},{"type":"module","title":"Rivet.Ident.UserCode.Lib","doc":"","ref":"Rivet.Ident.UserCode.Lib.html"},{"type":"function","title":"Rivet.Ident.UserCode.Lib.clear_all_codes/2","doc":"","ref":"Rivet.Ident.UserCode.Lib.html#clear_all_codes/2"},{"type":"function","title":"Rivet.Ident.UserCode.Lib.clear_expired_codes/0","doc":"","ref":"Rivet.Ident.UserCode.Lib.html#clear_expired_codes/0"},{"type":"function","title":"Rivet.Ident.UserCode.Lib.generate_code/4","doc":"","ref":"Rivet.Ident.UserCode.Lib.html#generate_code/4"},{"type":"type","title":"Rivet.Ident.UserCode.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserCode.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserCode.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.UserCode.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.UserData","doc":"Schema for representing and working with a Ident.UserData.","ref":"Rivet.Ident.UserData.html"},{"type":"function","title":"Rivet.Ident.UserData.aggregate/2","doc":"","ref":"Rivet.Ident.UserData.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.UserData.all/2","doc":"","ref":"Rivet.Ident.UserData.html#all/2"},{"type":"function","title":"Rivet.Ident.UserData.all!/2","doc":"","ref":"Rivet.Ident.UserData.html#all!/2"},{"type":"function","title":"Rivet.Ident.UserData.associate/3","doc":"","ref":"Rivet.Ident.UserData.html#associate/3"},{"type":"function","title":"Rivet.Ident.UserData.build/1","doc":"","ref":"Rivet.Ident.UserData.html#build/1"},{"type":"function","title":"Rivet.Ident.UserData.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserData.html#change_post/2"},{"type":"function","title":"Rivet.Ident.UserData.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserData.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.UserData.changeset/2","doc":"","ref":"Rivet.Ident.UserData.html#changeset/2"},{"type":"function","title":"Rivet.Ident.UserData.count!/0","doc":"","ref":"Rivet.Ident.UserData.html#count!/0"},{"type":"function","title":"Rivet.Ident.UserData.count!/1","doc":"","ref":"Rivet.Ident.UserData.html#count!/1"},{"type":"function","title":"Rivet.Ident.UserData.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.UserData.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.UserData.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.UserData.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.UserData.count_by_updated!/0","doc":"","ref":"Rivet.Ident.UserData.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.UserData.count_by_updated!/1","doc":"","ref":"Rivet.Ident.UserData.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.UserData.create/1","doc":"","ref":"Rivet.Ident.UserData.html#create/1"},{"type":"function","title":"Rivet.Ident.UserData.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserData.html#create_post/2"},{"type":"function","title":"Rivet.Ident.UserData.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserData.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.UserData.delete/1","doc":"","ref":"Rivet.Ident.UserData.html#delete/1"},{"type":"function","title":"Rivet.Ident.UserData.delete_all/2","doc":"","ref":"Rivet.Ident.UserData.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.UserData.delete_all_ids/2","doc":"","ref":"Rivet.Ident.UserData.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.UserData.drop_replace/2","doc":"","ref":"Rivet.Ident.UserData.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.UserData.exists?/1","doc":"","ref":"Rivet.Ident.UserData.html#exists?/1"},{"type":"function","title":"Rivet.Ident.UserData.full_table_scan/2","doc":"","ref":"Rivet.Ident.UserData.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.UserData.insert/2","doc":"","ref":"Rivet.Ident.UserData.html#insert/2"},{"type":"function","title":"Rivet.Ident.UserData.latest/2","doc":"","ref":"Rivet.Ident.UserData.html#latest/2"},{"type":"function","title":"Rivet.Ident.UserData.latest!/2","doc":"","ref":"Rivet.Ident.UserData.html#latest!/2"},{"type":"function","title":"Rivet.Ident.UserData.one/2","doc":"","ref":"Rivet.Ident.UserData.html#one/2"},{"type":"function","title":"Rivet.Ident.UserData.one!/2","doc":"","ref":"Rivet.Ident.UserData.html#one!/2"},{"type":"function","title":"Rivet.Ident.UserData.preload/3","doc":"","ref":"Rivet.Ident.UserData.html#preload/3"},{"type":"function","title":"Rivet.Ident.UserData.preload!/3","doc":"","ref":"Rivet.Ident.UserData.html#preload!/3"},{"type":"function","title":"Rivet.Ident.UserData.replace/2","doc":"","ref":"Rivet.Ident.UserData.html#replace/2"},{"type":"function","title":"Rivet.Ident.UserData.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserData.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.UserData.stream/2","doc":"","ref":"Rivet.Ident.UserData.html#stream/2"},{"type":"function","title":"Rivet.Ident.UserData.stream_all!/2","doc":"","ref":"Rivet.Ident.UserData.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.UserData.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.UserData.html#touch/1"},{"type":"function","title":"Rivet.Ident.UserData.unload/1","doc":"","ref":"Rivet.Ident.UserData.html#unload/1"},{"type":"function","title":"Rivet.Ident.UserData.unload/2","doc":"","ref":"Rivet.Ident.UserData.html#unload/2"},{"type":"function","title":"Rivet.Ident.UserData.update/2","doc":"","ref":"Rivet.Ident.UserData.html#update/2"},{"type":"function","title":"Rivet.Ident.UserData.update!/2","doc":"","ref":"Rivet.Ident.UserData.html#update!/2"},{"type":"function","title":"Rivet.Ident.UserData.update_all/2","doc":"","ref":"Rivet.Ident.UserData.html#update_all/2"},{"type":"function","title":"Rivet.Ident.UserData.update_fill/2","doc":"","ref":"Rivet.Ident.UserData.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.UserData.upsert/2","doc":"","ref":"Rivet.Ident.UserData.html#upsert/2"},{"type":"function","title":"Rivet.Ident.UserData.validate/1","doc":"","ref":"Rivet.Ident.UserData.html#validate/1"},{"type":"type","title":"Rivet.Ident.UserData.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserData.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserData.id/0","doc":"","ref":"Rivet.Ident.UserData.html#t:id/0"},{"type":"type","title":"Rivet.Ident.UserData.model_p_result/0","doc":"","ref":"Rivet.Ident.UserData.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.UserData.t/0","doc":"","ref":"Rivet.Ident.UserData.html#t:t/0"},{"type":"module","title":"Rivet.Ident.UserData.Lib","doc":"","ref":"Rivet.Ident.UserData.Lib.html"},{"type":"function","title":"Rivet.Ident.UserData.Lib.list_types/2","doc":"","ref":"Rivet.Ident.UserData.Lib.html#list_types/2"},{"type":"type","title":"Rivet.Ident.UserData.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserData.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserData.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.UserData.Lib.html#t:model_p_result/0"},{"type":"module","title":"Rivet.Ident.UserData.Types","doc":"","ref":"Rivet.Ident.UserData.Types.html"},{"type":"function","title":"Rivet.Ident.UserData.Types.cast/1","doc":"","ref":"Rivet.Ident.UserData.Types.html#cast/1"},{"type":"function","title":"Rivet.Ident.UserData.Types.dump/1","doc":"","ref":"Rivet.Ident.UserData.Types.html#dump/1"},{"type":"function","title":"Rivet.Ident.UserData.Types.embed_as/1","doc":"","ref":"Rivet.Ident.UserData.Types.html#embed_as/1"},{"type":"function","title":"Rivet.Ident.UserData.Types.equal?/2","doc":"","ref":"Rivet.Ident.UserData.Types.html#equal?/2"},{"type":"function","title":"Rivet.Ident.UserData.Types.load/1","doc":"","ref":"Rivet.Ident.UserData.Types.html#load/1"},{"type":"function","title":"Rivet.Ident.UserData.Types.type/0","doc":"","ref":"Rivet.Ident.UserData.Types.html#type/0"},{"type":"function","title":"Rivet.Ident.UserData.Types.valid_value?/1","doc":"","ref":"Rivet.Ident.UserData.Types.html#valid_value?/1"},{"type":"type","title":"Rivet.Ident.UserData.Types.t/0","doc":"","ref":"Rivet.Ident.UserData.Types.html#t:t/0"},{"type":"module","title":"Rivet.Ident.UserIdent","doc":"","ref":"Rivet.Ident.UserIdent.html"},{"type":"function","title":"Rivet.Ident.UserIdent.aggregate/2","doc":"","ref":"Rivet.Ident.UserIdent.html#aggregate/2"},{"type":"function","title":"Rivet.Ident.UserIdent.all/2","doc":"","ref":"Rivet.Ident.UserIdent.html#all/2"},{"type":"function","title":"Rivet.Ident.UserIdent.all!/2","doc":"","ref":"Rivet.Ident.UserIdent.html#all!/2"},{"type":"function","title":"Rivet.Ident.UserIdent.associate/3","doc":"","ref":"Rivet.Ident.UserIdent.html#associate/3"},{"type":"function","title":"Rivet.Ident.UserIdent.build/1","doc":"","ref":"Rivet.Ident.UserIdent.html#build/1"},{"type":"function","title":"Rivet.Ident.UserIdent.change_post/2","doc":"change_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserIdent.html#change_post/2"},{"type":"function","title":"Rivet.Ident.UserIdent.change_prep/2","doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserIdent.html#change_prep/2"},{"type":"function","title":"Rivet.Ident.UserIdent.changeset/2","doc":"","ref":"Rivet.Ident.UserIdent.html#changeset/2"},{"type":"function","title":"Rivet.Ident.UserIdent.count!/0","doc":"","ref":"Rivet.Ident.UserIdent.html#count!/0"},{"type":"function","title":"Rivet.Ident.UserIdent.count!/1","doc":"","ref":"Rivet.Ident.UserIdent.html#count!/1"},{"type":"function","title":"Rivet.Ident.UserIdent.count_by_inserted!/0","doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_inserted!/0"},{"type":"function","title":"Rivet.Ident.UserIdent.count_by_inserted!/1","doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_inserted!/1"},{"type":"function","title":"Rivet.Ident.UserIdent.count_by_updated!/0","doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_updated!/0"},{"type":"function","title":"Rivet.Ident.UserIdent.count_by_updated!/1","doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_updated!/1"},{"type":"function","title":"Rivet.Ident.UserIdent.create/1","doc":"","ref":"Rivet.Ident.UserIdent.html#create/1"},{"type":"function","title":"Rivet.Ident.UserIdent.create_post/2","doc":"create_post for side effects; should return the item\n\nNote: BE VERY CAREFUL on large impact effects. This can quickly become\na performance bottleneck.","ref":"Rivet.Ident.UserIdent.html#create_post/2"},{"type":"function","title":"Rivet.Ident.UserIdent.create_prep/2","doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserIdent.html#create_prep/2"},{"type":"function","title":"Rivet.Ident.UserIdent.delete/1","doc":"","ref":"Rivet.Ident.UserIdent.html#delete/1"},{"type":"function","title":"Rivet.Ident.UserIdent.delete_all/2","doc":"","ref":"Rivet.Ident.UserIdent.html#delete_all/2"},{"type":"function","title":"Rivet.Ident.UserIdent.delete_all_ids/2","doc":"","ref":"Rivet.Ident.UserIdent.html#delete_all_ids/2"},{"type":"function","title":"Rivet.Ident.UserIdent.drop_replace/2","doc":"","ref":"Rivet.Ident.UserIdent.html#drop_replace/2"},{"type":"function","title":"Rivet.Ident.UserIdent.exists?/1","doc":"","ref":"Rivet.Ident.UserIdent.html#exists?/1"},{"type":"function","title":"Rivet.Ident.UserIdent.full_table_scan/2","doc":"","ref":"Rivet.Ident.UserIdent.html#full_table_scan/2"},{"type":"function","title":"Rivet.Ident.UserIdent.insert/2","doc":"","ref":"Rivet.Ident.UserIdent.html#insert/2"},{"type":"function","title":"Rivet.Ident.UserIdent.latest/2","doc":"","ref":"Rivet.Ident.UserIdent.html#latest/2"},{"type":"function","title":"Rivet.Ident.UserIdent.latest!/2","doc":"","ref":"Rivet.Ident.UserIdent.html#latest!/2"},{"type":"function","title":"Rivet.Ident.UserIdent.one/2","doc":"","ref":"Rivet.Ident.UserIdent.html#one/2"},{"type":"function","title":"Rivet.Ident.UserIdent.one!/2","doc":"","ref":"Rivet.Ident.UserIdent.html#one!/2"},{"type":"function","title":"Rivet.Ident.UserIdent.preload/3","doc":"","ref":"Rivet.Ident.UserIdent.html#preload/3"},{"type":"function","title":"Rivet.Ident.UserIdent.preload!/3","doc":"","ref":"Rivet.Ident.UserIdent.html#preload!/3"},{"type":"function","title":"Rivet.Ident.UserIdent.replace/2","doc":"","ref":"Rivet.Ident.UserIdent.html#replace/2"},{"type":"function","title":"Rivet.Ident.UserIdent.replace_fill/2","doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserIdent.html#replace_fill/2"},{"type":"function","title":"Rivet.Ident.UserIdent.stream/2","doc":"","ref":"Rivet.Ident.UserIdent.html#stream/2"},{"type":"function","title":"Rivet.Ident.UserIdent.stream_all!/2","doc":"","ref":"Rivet.Ident.UserIdent.html#stream_all!/2"},{"type":"function","title":"Rivet.Ident.UserIdent.touch/1","doc":"Update our updated_at but only if it hasn't changed within a minute\n(less load)","ref":"Rivet.Ident.UserIdent.html#touch/1"},{"type":"function","title":"Rivet.Ident.UserIdent.unload/1","doc":"","ref":"Rivet.Ident.UserIdent.html#unload/1"},{"type":"function","title":"Rivet.Ident.UserIdent.unload/2","doc":"","ref":"Rivet.Ident.UserIdent.html#unload/2"},{"type":"function","title":"Rivet.Ident.UserIdent.update/2","doc":"","ref":"Rivet.Ident.UserIdent.html#update/2"},{"type":"function","title":"Rivet.Ident.UserIdent.update!/2","doc":"","ref":"Rivet.Ident.UserIdent.html#update!/2"},{"type":"function","title":"Rivet.Ident.UserIdent.update_all/2","doc":"","ref":"Rivet.Ident.UserIdent.html#update_all/2"},{"type":"function","title":"Rivet.Ident.UserIdent.update_fill/2","doc":"","ref":"Rivet.Ident.UserIdent.html#update_fill/2"},{"type":"function","title":"Rivet.Ident.UserIdent.upsert/2","doc":"","ref":"Rivet.Ident.UserIdent.html#upsert/2"},{"type":"function","title":"Rivet.Ident.UserIdent.validate/1","doc":"","ref":"Rivet.Ident.UserIdent.html#validate/1"},{"type":"type","title":"Rivet.Ident.UserIdent.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserIdent.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserIdent.id/0","doc":"","ref":"Rivet.Ident.UserIdent.html#t:id/0"},{"type":"type","title":"Rivet.Ident.UserIdent.model_p_result/0","doc":"","ref":"Rivet.Ident.UserIdent.html#t:model_p_result/0"},{"type":"type","title":"Rivet.Ident.UserIdent.t/0","doc":"","ref":"Rivet.Ident.UserIdent.html#t:t/0"},{"type":"module","title":"Rivet.Ident.UserIdent.Lib","doc":"","ref":"Rivet.Ident.UserIdent.Lib.html"},{"type":"function","title":"Rivet.Ident.UserIdent.Lib.get/2","doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#get/2"},{"type":"function","title":"Rivet.Ident.UserIdent.Lib.put/3","doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#put/3"},{"type":"type","title":"Rivet.Ident.UserIdent.Lib.ecto_p_result/0","doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#t:ecto_p_result/0"},{"type":"type","title":"Rivet.Ident.UserIdent.Lib.model_p_result/0","doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#t:model_p_result/0"}],"content_type":"text/markdown"}