searchNodes=[{"doc":"Public interface to authentication and authorization functions.","ref":"Rivet.Auth.html","title":"Rivet.Auth","type":"module"},{"doc":"","ref":"Rivet.Auth.html#authz_action/4","title":"Rivet.Auth.authz_action/4","type":"function"},{"doc":"","ref":"Rivet.Auth.html#change_password/2","title":"Rivet.Auth.change_password/2","type":"function"},{"doc":"","ref":"Rivet.Auth.html#change_password/3","title":"Rivet.Auth.change_password/3","type":"function"},{"doc":"","ref":"Rivet.Auth.html#check_authz/2","title":"Rivet.Auth.check_authz/2","type":"function"},{"doc":"Validation of tokens for accessing site (after refresh) Note: this is the start of the next iteration, and it will replace Rivet.Auth.Token","ref":"Rivet.Auth.Access.html","title":"Rivet.Auth.Access","type":"module"},{"doc":"iex&gt; alias Rivet.Auth iex&gt; check([&quot;&quot;], %Auth.Domain{}) {:missing, %Auth.Domain{log: &quot;Missing authorization header value&quot;}} iex&gt; check([], %Auth.Domain{}) {:missing, %Auth.Domain{log: &quot;Missing authorization header value&quot;}} iex&gt; check([&quot;bearer token&quot;], %Auth.Domain{}) {:error, %Auth.Domain{log: &quot;Invalid authorization&quot;}} iex&gt; check([&quot;narf&quot;], %Auth.Domain{}) {:error, %Auth.Domain{log: &quot;Authorization header exists but is not formatted properly&quot;}} iex&gt; check([&quot;narf narf&quot;], %Auth.Domain{}) {:error, %Auth.Domain{log: &quot;Invalid authorization type: narf&quot;}}","ref":"Rivet.Auth.Access.html#check/2","title":"Rivet.Auth.Access.check/2","type":"function"},{"doc":"Used for standardizing auth assertion checks. Passed in when declaring what type of auth is needed","ref":"Rivet.Auth.Assertion.html","title":"Rivet.Auth.Assertion","type":"module"},{"doc":"","ref":"Rivet.Auth.Assertion.html#t:t/0","title":"Rivet.Auth.Assertion.t/0","type":"type"},{"doc":"Structure for in-process authentication result contexts, not directly to one user","ref":"Rivet.Auth.Domain.html","title":"Rivet.Auth.Domain","type":"module"},{"doc":"","ref":"Rivet.Auth.Domain.html#t:result/0","title":"Rivet.Auth.Domain.result/0","type":"type"},{"doc":"","ref":"Rivet.Auth.Domain.html#t:t/0","title":"Rivet.Auth.Domain.t/0","type":"type"},{"doc":"Helpers for Graphql resolvers.","ref":"Rivet.Auth.Graphql.html","title":"Rivet.Auth.Graphql","type":"module"},{"doc":"","ref":"Rivet.Auth.Graphql.html#action/2","title":"Rivet.Auth.Graphql.action/2","type":"function"},{"doc":"This wraps check_authz with logging and creates normal error output for Absinthe to handle. with { :ok , authed } &lt;- authz ( context , % Rivet.Auth.Assertion { } , &quot;doTheThing&quot; ) do handle success end","ref":"Rivet.Auth.Graphql.html#authz/4","title":"Rivet.Auth.Graphql.authz/4","type":"function"},{"doc":"Accept authorization from a user. Punt to authz_action(), but log graphql bits.","ref":"Rivet.Auth.Graphql.html#authz_user/4","title":"Rivet.Auth.Graphql.authz_user/4","type":"function"},{"doc":"check_authz/2 attempts to verify %Auth.Assertion{} against the specified user, and if the assertion includes a domain reference, it will attempt to walk up the reference tree (if a parent_id exists) and try checking auth again.","ref":"Rivet.Auth.Graphql.html#check_authz/2","title":"Rivet.Auth.Graphql.check_authz/2","type":"function"},{"doc":"Handles extracting the current user from the Absinthe context, and then will either call func and pass in the current user or return an error if there is no user in the context","ref":"Rivet.Auth.Graphql.html#current_user/1","title":"Rivet.Auth.Graphql.current_user/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Graphql.html#current_user/2","title":"Rivet.Auth.Graphql.current_user/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Graphql.html#t:az_assertion/0","title":"Rivet.Auth.Graphql.az_assertion/0","type":"type"},{"doc":"","ref":"Rivet.Auth.Graphql.html#t:az_log/0","title":"Rivet.Auth.Graphql.az_log/0","type":"type"},{"doc":"","ref":"Rivet.Auth.Graphql.html#t:az_user/0","title":"Rivet.Auth.Graphql.az_user/0","type":"type"},{"doc":"","ref":"Rivet.Auth.Identify.html","title":"Rivet.Auth.Identify","type":"module"},{"doc":"","ref":"Rivet.Auth.Identify.html#identify/2","title":"Rivet.Auth.Identify.identify/2","type":"function"},{"doc":"Tooling for the second phase of auth: Refresh TODO: Extract from Phoenix/WebSvc better, abstract so conn isn't needed This will require a module that is imported into WebSvc - BJG","ref":"Rivet.Auth.Refresh.html","title":"Rivet.Auth.Refresh","type":"module"},{"doc":"extract the validaton token from the refresh token decode &amp; verify the validation token is ours &amp; good using the sub:uuid from the validation token, verify the signature on the ref token update connection data (or abort) iex&gt; assure(%Auth.Domain{}, nil) {:error, %Auth.Domain{log: &quot;Invalid refresh request&quot;}}","ref":"Rivet.Auth.Refresh.html#assure/2","title":"Rivet.Auth.Refresh.assure/2","type":"function"},{"doc":"iex&gt; {:error, &quot;narf!&quot;} = check_refresh_token({:error, &quot;narf!&quot;})","ref":"Rivet.Auth.Refresh.html#check_refresh_token/1","title":"Rivet.Auth.Refresh.check_refresh_token/1","type":"function"},{"doc":"iex&gt; {:error, %Auth.Domain{log: &quot;Invalid authorization&quot;}} = extract_validation_token({:ok, %{sub: &quot;cas2:asdf&quot;}}, %Auth.Domain{}) iex&gt; {:error, %Auth.Domain{log: &quot;Unable to match validation token subject: \\&quot;wut\\&quot;&quot;}} = extract_validation_token({:ok, &quot;wut&quot;}, %Auth.Domain{}) iex&gt; {:error, %Auth.Domain{log: &quot;narf!&quot;}} = extract_validation_token({:error, &quot;narf!&quot;}, %Auth.Domain{})","ref":"Rivet.Auth.Refresh.html#extract_validation_token/2","title":"Rivet.Auth.Refresh.extract_validation_token/2","type":"function"},{"doc":"How we are configured globally","ref":"Rivet.Auth.Settings.html","title":"Rivet.Auth.Settings","type":"module"},{"doc":"Get the most current secret based on token type(:acc, :val etc..), for jwt hashes","ref":"Rivet.Auth.Settings.html#current_jwt_secret/1","title":"Rivet.Auth.Settings.current_jwt_secret/1","type":"function"},{"doc":"Called by Application.start, to configure the runtime state from other sources","ref":"Rivet.Auth.Settings.html#decode_secrets/1","title":"Rivet.Auth.Settings.decode_secrets/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Settings.html#expire_limit/2","title":"Rivet.Auth.Settings.expire_limit/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Settings.html#getcfg/2","title":"Rivet.Auth.Settings.getcfg/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Settings.html#putcfg/2","title":"Rivet.Auth.Settings.putcfg/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Settings.html#secret_keys/1","title":"Rivet.Auth.Settings.secret_keys/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Settings.html#start/0","title":"Rivet.Auth.Settings.start/0","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.html","title":"Rivet.Auth.Signin","type":"module"},{"doc":"","ref":"Rivet.Auth.Signin.html#post_signin/1","title":"Rivet.Auth.Signin.post_signin/1","type":"function"},{"doc":"Google login scheme","ref":"Rivet.Auth.Signin.Google.html","title":"Rivet.Auth.Signin.Google","type":"module"},{"doc":"","ref":"Rivet.Auth.Signin.Google.html#check/2","title":"Rivet.Auth.Signin.Google.check/2","type":"function"},{"doc":"Syntactic sugar to wrap the HTTP call in requesting the keys. Questionable if this is worthwhile, but it's working now...","ref":"Rivet.Auth.Signin.Google.AuthKeys.html","title":"Rivet.Auth.Signin.Google.AuthKeys","type":"module"},{"doc":"","ref":"Rivet.Auth.Signin.Google.AuthKeys.html#get!/1","title":"Rivet.Auth.Signin.Google.AuthKeys.get!/1","type":"function"},{"doc":"This module runs as a separate process which keeps google's oauth public keys current, as they change weekly. This process inspects the expiration date (which google says should be correct) and updates at least by then, but does not wait longer than 1 day.","ref":"Rivet.Auth.Signin.Google.KeyManager.html","title":"Rivet.Auth.Signin.Google.KeyManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Rivet.Auth.Signin.Google.KeyManager.html#child_spec/1","title":"Rivet.Auth.Signin.Google.KeyManager.child_spec/1","type":"function"},{"doc":"External interface to request a current copy of the keys for google iex&gt; dict = Rivet.Auth.Signin.Google.KeyManager.get_keys() iex&gt; is_map(dict) true","ref":"Rivet.Auth.Signin.Google.KeyManager.html#get_keys/0","title":"Rivet.Auth.Signin.Google.KeyManager.get_keys/0","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Rivet.Auth.Signin.Google.KeyManager.html#init/1","title":"Rivet.Auth.Signin.Google.KeyManager.init/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Google.KeyManager.html#start_link/1","title":"Rivet.Auth.Signin.Google.KeyManager.start_link/1","type":"function"},{"doc":"Local login scheme","ref":"Rivet.Auth.Signin.Local.html","title":"Rivet.Auth.Signin.Local","type":"module"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#check/2","title":"Rivet.Auth.Signin.Local.check/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#check_password/2","title":"Rivet.Auth.Signin.Local.check_password/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#load_password_factor/1","title":"Rivet.Auth.Signin.Local.load_password_factor/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#load_user/2","title":"Rivet.Auth.Signin.Local.load_user/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#signup/2","title":"Rivet.Auth.Signin.Local.signup/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Signin.Local.html#valid_user_factor/2","title":"Rivet.Auth.Signin.Local.valid_user_factor/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Token.html","title":"Rivet.Auth.Token","type":"module"},{"doc":"iex&gt; jwt = &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOiJjYWExOmFjYzpleGFtcGxlLmNvbSIsImV4cCI6MTY3MTkyMjMwMCwiZm9yIjp7fSwic3ViIjoiY2FzMTpuYXJmIn0.N6PV_XAGTjymi1CEfVkKRj433S0XBlTxcevL7VAhTRY&quot; iex&gt; extract(jwt, :all) {:ok, %{&quot;alg&quot; =&gt; &quot;HS256&quot;,&quot;typ&quot; =&gt; &quot;JWT&quot;}, %{aud: &quot;caa1:acc:example.com&quot;, exp: 1671922300, for: %{}, sub: &quot;cas1:narf&quot;}} iex&gt; extract(jwt, :claims) {:ok, %{aud: &quot;caa1:acc:example.com&quot;, exp: 1671922300, for: %{}, sub: &quot;cas1:narf&quot;}} iex&gt; extract(jwt, :header) {:ok, %{&quot;alg&quot; =&gt; &quot;HS256&quot;,&quot;typ&quot; =&gt; &quot;JWT&quot;}} iex&gt; extract(&quot;asdf&quot;, :all) iex&gt; extract(&quot;asdf.asdf.asdf&quot;, :all)","ref":"Rivet.Auth.Token.html#extract/2","title":"Rivet.Auth.Token.extract/2","type":"function"},{"doc":"","ref":"Rivet.Auth.Token.Access.html","title":"Rivet.Auth.Token.Access","type":"module"},{"doc":"Generate an auth JWT to our specification iex&gt; alias Rivet.Ident.Factor iex&gt; {:ok, token, claims} = jwt(%Factor{id: &quot;AB&quot;, details: %{type: &quot;acc&quot;}}, &quot;example.com&quot;, 5*60) iex&gt; claims.aud &quot;caa1:acc:example.com&quot; iex&gt; claims.sub &quot;cas1:AB&quot; iex&gt; String.slice(token, 0..1) &quot;ey&quot; iex&gt; {:ok, token, claims} = jwt(&quot;narf&quot;, &quot;example.com&quot;, 5*60) iex&gt; claims.aud &quot;caa1:acc:example.com&quot; iex&gt; claims.sub &quot;cas1:narf&quot; iex&gt; String.slice(token, 0..1) &quot;ey&quot; iex&gt; {:ok, &quot;ey&quot; &lt;&gt; _rest, %{sub: &quot;cas1:userid&quot;}} = jwt(&quot;userid&quot;, &quot;hostname&quot;)","ref":"Rivet.Auth.Token.Access.html#jwt/3","title":"Rivet.Auth.Token.Access.jwt/3","type":"function"},{"doc":"Validate tokens are meeting our requirements","ref":"Rivet.Auth.Token.Check.html","title":"Rivet.Auth.Token.Check","type":"module"},{"doc":"iex&gt; alias Rivet.Ident.Auth.Domain iex&gt; {:error, auth} = enrich_sub_aud(%Auth.Domain{token: %{claims: %{sub: &quot;asdf&quot;, aud: &quot;asdf&quot;}}}) iex&gt; auth.log &quot;Cannot parse token.sub=asdf&quot;","ref":"Rivet.Auth.Token.Check.html#enrich_sub_aud/1","title":"Rivet.Auth.Token.Check.enrich_sub_aud/1","type":"function"},{"doc":"Checks payload information to verify proper authorization matches iex&gt; {:ok, _token, claims} = Rivet.Auth.Token.Access.jwt(&quot;narf&quot;, &quot;example.com&quot;, 5) ...&gt; {:error, %Auth.Domain{} = a} = jwt(%Auth.Domain{hostname: &quot;example.com&quot;, token: %{claims: claims}}) ...&gt; a.log &quot;Cannot find identity factor=narf&quot;","ref":"Rivet.Auth.Token.Check.html#jwt/1","title":"Rivet.Auth.Token.Check.jwt/1","type":"function"},{"doc":"iex&gt; alias Rivet.Ident.Auth.Domain iex&gt; {:error, auth} = valid_audience(%Auth.Domain{token: %{aud: &quot;asdf&quot;}}) iex&gt; auth.log &quot;Cannot parse token.tok=asdf&quot; iex&gt; {:error, auth} = valid_audience(%Auth.Domain{token: %{aud: &quot;key:a.domain&quot;}, hostname: &quot;b.domain&quot;}) iex&gt; auth.log &quot;Token audience does not match: a.domain != b.domain&quot; iex&gt; valid_audience({:error, &quot;narf&quot;})","ref":"Rivet.Auth.Token.Check.html#valid_audience/1","title":"Rivet.Auth.Token.Check.valid_audience/1","type":"function"},{"doc":"iex&gt; alias Rivet.Ident.Auth.Domain iex&gt; now = System.os_time(:second) iex&gt; {:error, auth} = valid_expiration(%Auth.Domain{token: %{claims: %{for: %{}, exp: 0}}, type: :acc}) iex&gt; auth.log &quot;Token Expired&quot; iex&gt; {:error, auth} = valid_expiration(%Auth.Domain{token: %{claims: %{for: %{}, exp: now+300000}}, type: :acc}) iex&gt; auth.log &quot;Token expiration out of bounds&quot; iex&gt; valid_expiration({:error, &quot;narf&quot;})","ref":"Rivet.Auth.Token.Check.html#valid_expiration/1","title":"Rivet.Auth.Token.Check.valid_expiration/1","type":"function"},{"doc":"iex&gt; alias Rivet.Ident.Auth.Domain iex&gt; {:error, auth} = valid_subject(%Auth.Domain{}) iex&gt; auth.log &quot;Unable to process token subject&quot; iex&gt; {:error, auth} = valid_subject(%Auth.Domain{token: %{claims: %{sub: &quot;red&quot;}}, type: :acc}) iex&gt; auth.log &quot;Cannot parse token.sub=red&quot; iex&gt; {:error, auth} = valid_subject(%Auth.Domain{type: :acc, token: %{sub_type: :cas1, sub: &quot;subject&quot;}}) iex&gt; auth.log &quot;Cannot find identity factor=subject&quot; iex&gt; {:error, auth} = valid_subject(%Auth.Domain{token: %{aud_type: :caa1, sub_type: :cas1, sub: &quot;subject&quot;}, type: :val}) iex&gt; auth.log &quot;Cannot find identity factor=subject&quot; iex&gt; valid_subject({:error, &quot;narf&quot;})","ref":"Rivet.Auth.Token.Check.html#valid_subject/1","title":"Rivet.Auth.Token.Check.valid_subject/1","type":"function"},{"doc":"","ref":"Rivet.Auth.Token.Create.html","title":"Rivet.Auth.Token.Create","type":"module"},{"doc":"iex&gt; {:ok, _tok, claims} = jwt(:acc, &quot;narf&quot;, &quot;NARF&quot;, 10, &quot;narf&quot;, %{}) iex&gt; claims.aud &quot;caa1:acc:NARF&quot;","ref":"Rivet.Auth.Token.Create.html#jwt/7","title":"Rivet.Auth.Token.Create.jwt/7","type":"function"},{"doc":"","ref":"Rivet.Auth.Token.Validation.html","title":"Rivet.Auth.Token.Validation","type":"module"},{"doc":"","ref":"Rivet.Auth.Token.Validation.html#jwt/4","title":"Rivet.Auth.Token.Validation.jwt/4","type":"function"},{"doc":"","ref":"Rivet.Auth.Token.Validation.html#key/2","title":"Rivet.Auth.Token.Validation.key/2","type":"function"},{"doc":"Verify tokens meet our requirements","ref":"Rivet.Auth.Token.Verify.html","title":"Rivet.Auth.Token.Verify","type":"module"},{"doc":"Checks JWT against configured secrets for that type. Returns claims if a valid JWT is found, but does no authentication/authorization. NOTE: These test will stop working with diff jwt keys iex&gt; jwt(&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOiJjYWExOmFjYzpleGFtcGxlLmNvbSIsImV4cCI6MTY3ODMxMTEwMywiZm9yIjp7fSwic3ViIjoiY2FzMTpuYXJmIn0.qMH6Tr_vvfQ4lmLnPilordYbfgv4ZDzCY2yAc8D8RVQ&quot;, :acc) {:ok, %{aud: &quot;caa1:acc:example.com&quot;, exp: 1678311103, for: %{}, sub: &quot;cas1:narf&quot;}}","ref":"Rivet.Auth.Token.Verify.html#jwt/2","title":"Rivet.Auth.Token.Verify.jwt/2","type":"function"},{"doc":"Schema for representing and working with a Ident.Access.","ref":"Rivet.Ident.Access.html","title":"Rivet.Ident.Access","type":"module"},{"doc":"","ref":"Rivet.Ident.Access.html#aggregate/2","title":"Rivet.Ident.Access.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#all/2","title":"Rivet.Ident.Access.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#all!/2","title":"Rivet.Ident.Access.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#associate/3","title":"Rivet.Ident.Access.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#build/1","title":"Rivet.Ident.Access.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Access.html#change_post/2","title":"Rivet.Ident.Access.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Access.html#change_prep/2","title":"Rivet.Ident.Access.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#changeset/2","title":"Rivet.Ident.Access.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count!/0","title":"Rivet.Ident.Access.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count!/1","title":"Rivet.Ident.Access.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count_by_inserted!/0","title":"Rivet.Ident.Access.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count_by_inserted!/1","title":"Rivet.Ident.Access.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count_by_updated!/0","title":"Rivet.Ident.Access.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#count_by_updated!/1","title":"Rivet.Ident.Access.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#create/1","title":"Rivet.Ident.Access.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Access.html#create_post/2","title":"Rivet.Ident.Access.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Access.html#create_prep/2","title":"Rivet.Ident.Access.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#delete/1","title":"Rivet.Ident.Access.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#delete_all/2","title":"Rivet.Ident.Access.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#delete_all_ids/2","title":"Rivet.Ident.Access.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#drop_replace/2","title":"Rivet.Ident.Access.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#exists?/1","title":"Rivet.Ident.Access.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#full_table_scan/2","title":"Rivet.Ident.Access.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#insert/2","title":"Rivet.Ident.Access.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#latest/2","title":"Rivet.Ident.Access.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#latest!/2","title":"Rivet.Ident.Access.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#one/2","title":"Rivet.Ident.Access.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#one!/2","title":"Rivet.Ident.Access.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#preload/3","title":"Rivet.Ident.Access.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#preload!/3","title":"Rivet.Ident.Access.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#replace/2","title":"Rivet.Ident.Access.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Access.html#replace_fill/2","title":"Rivet.Ident.Access.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#stream/2","title":"Rivet.Ident.Access.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#stream_all!/2","title":"Rivet.Ident.Access.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Access.html#touch/1","title":"Rivet.Ident.Access.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#unload/1","title":"Rivet.Ident.Access.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#unload/2","title":"Rivet.Ident.Access.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#update/2","title":"Rivet.Ident.Access.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#update!/2","title":"Rivet.Ident.Access.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#update_all/2","title":"Rivet.Ident.Access.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#update_fill/2","title":"Rivet.Ident.Access.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#upsert/2","title":"Rivet.Ident.Access.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#validate/1","title":"Rivet.Ident.Access.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.html#t:ecto_p_result/0","title":"Rivet.Ident.Access.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.html#t:id/0","title":"Rivet.Ident.Access.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.html#t:model_p_result/0","title":"Rivet.Ident.Access.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.html#t:t/0","title":"Rivet.Ident.Access.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.Domains.html","title":"Rivet.Ident.Access.Domains","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Rivet.Ident.Access.Domains.html#cast/1","title":"Rivet.Ident.Access.Domains.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Rivet.Ident.Access.Domains.html#dump/1","title":"Rivet.Ident.Access.Domains.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Rivet.Ident.Access.Domains.html#embed_as/1","title":"Rivet.Ident.Access.Domains.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Rivet.Ident.Access.Domains.html#equal?/2","title":"Rivet.Ident.Access.Domains.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Rivet.Ident.Access.Domains.html#load/1","title":"Rivet.Ident.Access.Domains.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Rivet.Ident.Access.Domains.html#type/0","title":"Rivet.Ident.Access.Domains.type/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Domains.html#valid_value?/1","title":"Rivet.Ident.Access.Domains.valid_value?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Domains.html#t:t/0","title":"Rivet.Ident.Access.Domains.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html","title":"Rivet.Ident.Access.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#add/3","title":"Rivet.Ident.Access.Lib.add/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#delete_by_user/1","title":"Rivet.Ident.Access.Lib.delete_by_user/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#delete_by_user/3","title":"Rivet.Ident.Access.Lib.delete_by_user/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#drop/3","title":"Rivet.Ident.Access.Lib.drop/3","type":"function"},{"doc":"Fold a list of accesses into a set of actions, using memory cache","ref":"Rivet.Ident.Access.Lib.html#get_actions/1","title":"Rivet.Ident.Access.Lib.get_actions/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#get_actions/3","title":"Rivet.Ident.Access.Lib.get_actions/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Access.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Access.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Access.Lib.model_p_result/0","type":"type"},{"doc":"Schema for representing and working with a Ident.Action.","ref":"Rivet.Ident.Action.html","title":"Rivet.Ident.Action","type":"module"},{"doc":"","ref":"Rivet.Ident.Action.html#aggregate/2","title":"Rivet.Ident.Action.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#all/2","title":"Rivet.Ident.Action.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#all!/2","title":"Rivet.Ident.Action.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#associate/3","title":"Rivet.Ident.Action.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#build/1","title":"Rivet.Ident.Action.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Action.html#change_post/2","title":"Rivet.Ident.Action.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Action.html#change_prep/2","title":"Rivet.Ident.Action.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#changeset/2","title":"Rivet.Ident.Action.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count!/0","title":"Rivet.Ident.Action.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count!/1","title":"Rivet.Ident.Action.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count_by_inserted!/0","title":"Rivet.Ident.Action.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count_by_inserted!/1","title":"Rivet.Ident.Action.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count_by_updated!/0","title":"Rivet.Ident.Action.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#count_by_updated!/1","title":"Rivet.Ident.Action.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#create/1","title":"Rivet.Ident.Action.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Action.html#create_post/2","title":"Rivet.Ident.Action.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Action.html#create_prep/2","title":"Rivet.Ident.Action.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#delete/1","title":"Rivet.Ident.Action.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#delete_all/2","title":"Rivet.Ident.Action.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#delete_all_ids/2","title":"Rivet.Ident.Action.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#drop_replace/2","title":"Rivet.Ident.Action.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#exists?/1","title":"Rivet.Ident.Action.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#full_table_scan/2","title":"Rivet.Ident.Action.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#insert/2","title":"Rivet.Ident.Action.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#latest/2","title":"Rivet.Ident.Action.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#latest!/2","title":"Rivet.Ident.Action.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#one/2","title":"Rivet.Ident.Action.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#one!/2","title":"Rivet.Ident.Action.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#preload/3","title":"Rivet.Ident.Action.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#preload!/3","title":"Rivet.Ident.Action.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#replace/2","title":"Rivet.Ident.Action.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Action.html#replace_fill/2","title":"Rivet.Ident.Action.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#stream/2","title":"Rivet.Ident.Action.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#stream_all!/2","title":"Rivet.Ident.Action.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Action.html#touch/1","title":"Rivet.Ident.Action.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#unload/1","title":"Rivet.Ident.Action.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#unload/2","title":"Rivet.Ident.Action.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#update/2","title":"Rivet.Ident.Action.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#update!/2","title":"Rivet.Ident.Action.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#update_all/2","title":"Rivet.Ident.Action.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#update_fill/2","title":"Rivet.Ident.Action.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#upsert/2","title":"Rivet.Ident.Action.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#validate/1","title":"Rivet.Ident.Action.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Action.html#t:ecto_p_result/0","title":"Rivet.Ident.Action.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Action.html#t:id/0","title":"Rivet.Ident.Action.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Action.html#t:model_p_result/0","title":"Rivet.Ident.Action.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Action.html#t:t/0","title":"Rivet.Ident.Action.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Action.Lib.html","title":"Rivet.Ident.Action.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Action.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Action.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Action.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Action.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Application.html","title":"Rivet.Ident.Application","type":"module"},{"doc":"Callback implementation for Application.start/2 .","ref":"Rivet.Ident.Application.html#start/2","title":"Rivet.Ident.Application.start/2","type":"function"},{"doc":"Schema for representing and working with a Ident.Email.","ref":"Rivet.Ident.Email.html","title":"Rivet.Ident.Email","type":"module"},{"doc":"","ref":"Rivet.Ident.Email.html#aggregate/2","title":"Rivet.Ident.Email.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#all/2","title":"Rivet.Ident.Email.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#all!/2","title":"Rivet.Ident.Email.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#associate/3","title":"Rivet.Ident.Email.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#build/1","title":"Rivet.Ident.Email.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Email.html#change_post/2","title":"Rivet.Ident.Email.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Email.html#change_prep/2","title":"Rivet.Ident.Email.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#changeset/2","title":"Rivet.Ident.Email.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count!/0","title":"Rivet.Ident.Email.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count!/1","title":"Rivet.Ident.Email.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count_by_inserted!/0","title":"Rivet.Ident.Email.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count_by_inserted!/1","title":"Rivet.Ident.Email.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count_by_updated!/0","title":"Rivet.Ident.Email.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#count_by_updated!/1","title":"Rivet.Ident.Email.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#create/1","title":"Rivet.Ident.Email.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Email.html#create_post/2","title":"Rivet.Ident.Email.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Email.html#create_prep/2","title":"Rivet.Ident.Email.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#delete/1","title":"Rivet.Ident.Email.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#delete_all/2","title":"Rivet.Ident.Email.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#delete_all_ids/2","title":"Rivet.Ident.Email.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#drop_replace/2","title":"Rivet.Ident.Email.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#exists?/1","title":"Rivet.Ident.Email.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#full_table_scan/2","title":"Rivet.Ident.Email.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#insert/2","title":"Rivet.Ident.Email.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#latest/2","title":"Rivet.Ident.Email.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#latest!/2","title":"Rivet.Ident.Email.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#one/2","title":"Rivet.Ident.Email.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#one!/2","title":"Rivet.Ident.Email.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#preload/3","title":"Rivet.Ident.Email.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#preload!/3","title":"Rivet.Ident.Email.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#replace/2","title":"Rivet.Ident.Email.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Email.html#replace_fill/2","title":"Rivet.Ident.Email.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#stream/2","title":"Rivet.Ident.Email.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#stream_all!/2","title":"Rivet.Ident.Email.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Email.html#touch/1","title":"Rivet.Ident.Email.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#unload/1","title":"Rivet.Ident.Email.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#unload/2","title":"Rivet.Ident.Email.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#update/2","title":"Rivet.Ident.Email.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#update!/2","title":"Rivet.Ident.Email.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#update_all/2","title":"Rivet.Ident.Email.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#update_fill/2","title":"Rivet.Ident.Email.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#upsert/2","title":"Rivet.Ident.Email.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#validate/1","title":"Rivet.Ident.Email.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.html#t:ecto_p_result/0","title":"Rivet.Ident.Email.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Email.html#t:id/0","title":"Rivet.Ident.Email.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Email.html#t:model_p_result/0","title":"Rivet.Ident.Email.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Email.html#t:t/0","title":"Rivet.Ident.Email.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Email.Lib.html","title":"Rivet.Ident.Email.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Email.Lib.html#send_reset_code/1","title":"Rivet.Ident.Email.Lib.send_reset_code/1","type":"function"},{"doc":"Helper function which accepts either user_id or user, and calls the passed function with the user model loaded including any preloads. Send preloads as [] if none are desired.","ref":"Rivet.Ident.Email.Lib.html#with_email/3","title":"Rivet.Ident.Email.Lib.with_email/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Email.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Email.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Email.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Email.Lib.model_p_result/0","type":"type"},{"doc":"This is an example of how to deploy Rivet Email, and is included so other projects may include it in their tests.","ref":"Rivet.Ident.Example.Mailer.html","title":"Rivet.Ident.Example.Mailer","type":"module"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#deliver/3","title":"Rivet.Ident.Example.Mailer.deliver/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#get_emails/2","title":"Rivet.Ident.Example.Mailer.get_emails/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#log_email/1","title":"Rivet.Ident.Example.Mailer.log_email/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#send/3","title":"Rivet.Ident.Example.Mailer.send/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#send_email/1","title":"Rivet.Ident.Example.Mailer.send_email/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:email_model/0","title":"Rivet.Ident.Example.Mailer.email_model/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:email_recipient/0","title":"Rivet.Ident.Example.Mailer.email_recipient/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:user_id/0","title":"Rivet.Ident.Example.Mailer.user_id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.html#t:user_model/0","title":"Rivet.Ident.Example.Mailer.user_model/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html","title":"Rivet.Ident.Example.Mailer.Backend","type":"module"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver/2","title":"Rivet.Ident.Example.Mailer.Backend.deliver/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver!/2","title":"Rivet.Ident.Example.Mailer.Backend.deliver!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Backend.html#deliver_many/2","title":"Rivet.Ident.Example.Mailer.Backend.deliver_many/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html","title":"Rivet.Ident.Example.Mailer.Template","type":"module"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html#eval/3","title":"Rivet.Ident.Example.Mailer.Template.eval/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Example.Mailer.Template.html#load_and_eval/2","title":"Rivet.Ident.Example.Mailer.Template.load_and_eval/2","type":"function"},{"doc":"Schema for representing and working with an AuthFactor.","ref":"Rivet.Ident.Factor.html","title":"Rivet.Ident.Factor","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.html#aggregate/2","title":"Rivet.Ident.Factor.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#all/2","title":"Rivet.Ident.Factor.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#all!/2","title":"Rivet.Ident.Factor.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#associate/3","title":"Rivet.Ident.Factor.associate/3","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Factor.html#change_post/2","title":"Rivet.Ident.Factor.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Factor.html#change_prep/2","title":"Rivet.Ident.Factor.change_prep/2","type":"function"},{"doc":"Callback implementation for Rivet.Ecto.Collection.changeset/2 .","ref":"Rivet.Ident.Factor.html#changeset/2","title":"Rivet.Ident.Factor.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count!/0","title":"Rivet.Ident.Factor.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count!/1","title":"Rivet.Ident.Factor.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count_by_inserted!/0","title":"Rivet.Ident.Factor.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count_by_inserted!/1","title":"Rivet.Ident.Factor.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count_by_updated!/0","title":"Rivet.Ident.Factor.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#count_by_updated!/1","title":"Rivet.Ident.Factor.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#create/1","title":"Rivet.Ident.Factor.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Factor.html#create_post/2","title":"Rivet.Ident.Factor.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Factor.html#create_prep/2","title":"Rivet.Ident.Factor.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#delete/1","title":"Rivet.Ident.Factor.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#delete_all/2","title":"Rivet.Ident.Factor.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#delete_all_ids/2","title":"Rivet.Ident.Factor.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#drop_replace/2","title":"Rivet.Ident.Factor.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#exists?/1","title":"Rivet.Ident.Factor.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#full_table_scan/2","title":"Rivet.Ident.Factor.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#hash_password/1","title":"Rivet.Ident.Factor.hash_password/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#insert/2","title":"Rivet.Ident.Factor.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#latest/2","title":"Rivet.Ident.Factor.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#latest!/2","title":"Rivet.Ident.Factor.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#one/2","title":"Rivet.Ident.Factor.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#one!/2","title":"Rivet.Ident.Factor.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#preload/3","title":"Rivet.Ident.Factor.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#preload!/3","title":"Rivet.Ident.Factor.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#replace/2","title":"Rivet.Ident.Factor.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Factor.html#replace_fill/2","title":"Rivet.Ident.Factor.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#stream/2","title":"Rivet.Ident.Factor.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#stream_all!/2","title":"Rivet.Ident.Factor.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Factor.html#touch/1","title":"Rivet.Ident.Factor.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#unload/1","title":"Rivet.Ident.Factor.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#unload/2","title":"Rivet.Ident.Factor.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#update/2","title":"Rivet.Ident.Factor.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#update!/2","title":"Rivet.Ident.Factor.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#update_all/2","title":"Rivet.Ident.Factor.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#update_fill/2","title":"Rivet.Ident.Factor.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#upsert/2","title":"Rivet.Ident.Factor.upsert/2","type":"function"},{"doc":"Callback implementation for Rivet.Ecto.Collection.validate/1 .","ref":"Rivet.Ident.Factor.html#validate/1","title":"Rivet.Ident.Factor.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.html#t:ecto_p_result/0","title":"Rivet.Ident.Factor.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.html#t:id/0","title":"Rivet.Ident.Factor.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.html#t:model_p_result/0","title":"Rivet.Ident.Factor.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.html#t:t/0","title":"Rivet.Ident.Factor.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Cache.html","title":"Rivet.Ident.Factor.Cache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Rivet.Ident.Factor.Cache.html#child_spec/1","title":"Rivet.Ident.Factor.Cache.child_spec/1","type":"function"},{"doc":"Delete everything in the cache. Returns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.Factor.Cache.html#clear/0","title":"Rivet.Ident.Factor.Cache.clear/0","type":"function"},{"doc":"Delete anything by its key. Returns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.Factor.Cache.html#delete/1","title":"Rivet.Ident.Factor.Cache.delete/1","type":"function"},{"doc":"Read-through cache for loading user factors from Ident.","ref":"Rivet.Ident.Factor.Cache.html#get_user_factor/1","title":"Rivet.Ident.Factor.Cache.get_user_factor/1","type":"function"},{"doc":"Store anything for a certain amount of time or forever if no keep alive time specified Returns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.Factor.Cache.html#insert/3","title":"Rivet.Ident.Factor.Cache.insert/3","type":"function"},{"doc":"Retrieve anything by its key. Returns [{your_stored_tuple}] .","ref":"Rivet.Ident.Factor.Cache.html#lookup/1","title":"Rivet.Ident.Factor.Cache.lookup/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Cache.html#persist/1","title":"Rivet.Ident.Factor.Cache.persist/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Cache.html#purge_cache/0","title":"Rivet.Ident.Factor.Cache.purge_cache/0","type":"function"},{"doc":"Obtain the number of elements stored in the cache. Returns an integer equals or bigger than zero.","ref":"Rivet.Ident.Factor.Cache.html#size/0","title":"Rivet.Ident.Factor.Cache.size/0","type":"function"},{"doc":"Start scheduling the works for clearing the cache. This method should be called before performing any operation. Returns {:ok, PID} .","ref":"Rivet.Ident.Factor.Cache.html#start_link/1","title":"Rivet.Ident.Factor.Cache.start_link/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Cache.html#update_user/1","title":"Rivet.Ident.Factor.Cache.update_user/1","type":"function"},{"doc":"Structure for in-process authentication result contexts, not directly to one user","ref":"Rivet.Ident.Factor.FedId.html","title":"Rivet.Ident.Factor.FedId","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.FedId.html#t:t/0","title":"Rivet.Ident.Factor.FedId.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.FedId.Email.html","title":"Rivet.Ident.Factor.FedId.Email","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.FedId.Email.html#t:t/0","title":"Rivet.Ident.Factor.FedId.Email.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.FedId.Provider.html","title":"Rivet.Ident.Factor.FedId.Provider","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.FedId.Provider.html#t:t/0","title":"Rivet.Ident.Factor.FedId.Provider.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html","title":"Rivet.Ident.Factor.FederatedTypes","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#cast/1","title":"Rivet.Ident.Factor.FederatedTypes.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#dump/1","title":"Rivet.Ident.Factor.FederatedTypes.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#embed_as/1","title":"Rivet.Ident.Factor.FederatedTypes.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#equal?/2","title":"Rivet.Ident.Factor.FederatedTypes.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#load/1","title":"Rivet.Ident.Factor.FederatedTypes.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Rivet.Ident.Factor.FederatedTypes.html#type/0","title":"Rivet.Ident.Factor.FederatedTypes.type/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#valid_value?/1","title":"Rivet.Ident.Factor.FederatedTypes.valid_value?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.FederatedTypes.html#t:t/0","title":"Rivet.Ident.Factor.FederatedTypes.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html","title":"Rivet.Ident.Factor.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#all_not_expired!/1","title":"Rivet.Ident.Factor.Lib.all_not_expired!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#all_not_expired!/2","title":"Rivet.Ident.Factor.Lib.all_not_expired!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#clean_password_history/2","title":"Rivet.Ident.Factor.Lib.clean_password_history/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#drop_expired/0","title":"Rivet.Ident.Factor.Lib.drop_expired/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#get/1","title":"Rivet.Ident.Factor.Lib.get/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#get_user/1","title":"Rivet.Ident.Factor.Lib.get_user/1","type":"function"},{"doc":"Preload factors for a related model, with criteria, and only unexpired factors Ident.Factor.Lib . preloaded_with ( model , type )","ref":"Rivet.Ident.Factor.Lib.html#preloaded_with/2","title":"Rivet.Ident.Factor.Lib.preloaded_with/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#set_factor/2","title":"Rivet.Ident.Factor.Lib.set_factor/2","type":"function"},{"doc":"set a password Future change: change Ident.Factors so there is an archive state, some types when being cleaned are archived instead of deleted (such as passwords). Then Auth.Signin.Local.load_password_factor should filter on !archived","ref":"Rivet.Ident.Factor.Lib.html#set_password/3","title":"Rivet.Ident.Factor.Lib.set_password/3","type":"function"},{"doc":"iex&gt; strong_password(&quot;&lt;KO)(IJM,ko09ijm&quot;) :ok iex&gt; strong_password(&quot;boo&quot;) iex&gt; strong_password(&quot;&lt;ko)(ijm,ko09ijm&quot;) iex&gt; strong_password(&quot;KOIJMko09ijm&quot;) iex&gt; strong_password(&quot;&lt;KO)(IJM,koijm&quot;) iex&gt; strong_password(&quot;&lt;)(,)(*&amp;^%$#@&gt;&lt;&quot;)","ref":"Rivet.Ident.Factor.Lib.html#strong_password/1","title":"Rivet.Ident.Factor.Lib.strong_password/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:auth_result/0","title":"Rivet.Ident.Factor.Lib.auth_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Factor.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:log_msg/0","title":"Rivet.Ident.Factor.Lib.log_msg/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Factor.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:str/0","title":"Rivet.Ident.Factor.Lib.str/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Factor.Lib.html#t:usr_msg/0","title":"Rivet.Ident.Factor.Lib.usr_msg/0","type":"type"},{"doc":"Puid.generate/0 is included with the use statement below. It generates 18 random characters.","ref":"Rivet.Ident.Factor.Password.Puid.html","title":"Rivet.Ident.Factor.Password.Puid","type":"module"},{"doc":"Generate a puid","ref":"Rivet.Ident.Factor.Password.Puid.html#generate/0","title":"Rivet.Ident.Factor.Password.Puid.generate/0","type":"function"},{"doc":"Puid.Info module info","ref":"Rivet.Ident.Factor.Password.Puid.html#info/0","title":"Rivet.Ident.Factor.Password.Puid.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html","title":"Rivet.Ident.Factor.Password.Puid.Bits","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html#generate/0","title":"Rivet.Ident.Factor.Password.Puid.Bits.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Bits.html#reset/0","title":"Rivet.Ident.Factor.Password.Puid.Bits.reset/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Encoding.html","title":"Rivet.Ident.Factor.Password.Puid.Encoding","type":"module"},{"doc":"","ref":"Rivet.Ident.Factor.Password.Puid.Encoding.html#encode/1","title":"Rivet.Ident.Factor.Password.Puid.Encoding.encode/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Password.RandChars.html","title":"Rivet.Ident.Factor.Password.RandChars","type":"module"},{"doc":"random/0 generates a 72-character random string.","ref":"Rivet.Ident.Factor.Password.RandChars.html#generate/0","title":"Rivet.Ident.Factor.Password.RandChars.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Types.html","title":"Rivet.Ident.Factor.Types","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Rivet.Ident.Factor.Types.html#cast/1","title":"Rivet.Ident.Factor.Types.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Rivet.Ident.Factor.Types.html#dump/1","title":"Rivet.Ident.Factor.Types.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Rivet.Ident.Factor.Types.html#embed_as/1","title":"Rivet.Ident.Factor.Types.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Rivet.Ident.Factor.Types.html#equal?/2","title":"Rivet.Ident.Factor.Types.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Rivet.Ident.Factor.Types.html#load/1","title":"Rivet.Ident.Factor.Types.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Rivet.Ident.Factor.Types.html#type/0","title":"Rivet.Ident.Factor.Types.type/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Types.html#valid_value?/1","title":"Rivet.Ident.Factor.Types.valid_value?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Factor.Types.html#t:t/0","title":"Rivet.Ident.Factor.Types.t/0","type":"type"},{"doc":"Schema for representing and working with a Handle.","ref":"Rivet.Ident.Handle.html","title":"Rivet.Ident.Handle","type":"module"},{"doc":"","ref":"Rivet.Ident.Handle.html#aggregate/2","title":"Rivet.Ident.Handle.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#all/2","title":"Rivet.Ident.Handle.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#all!/2","title":"Rivet.Ident.Handle.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#associate/3","title":"Rivet.Ident.Handle.associate/3","type":"function"},{"doc":"Callback implementation for Rivet.Ecto.Collection.build/1 .","ref":"Rivet.Ident.Handle.html#build/1","title":"Rivet.Ident.Handle.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Handle.html#change_post/2","title":"Rivet.Ident.Handle.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Handle.html#change_prep/2","title":"Rivet.Ident.Handle.change_prep/2","type":"function"},{"doc":"Callback implementation for Rivet.Ecto.Collection.changeset/2 .","ref":"Rivet.Ident.Handle.html#changeset/2","title":"Rivet.Ident.Handle.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count!/0","title":"Rivet.Ident.Handle.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count!/1","title":"Rivet.Ident.Handle.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count_by_inserted!/0","title":"Rivet.Ident.Handle.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count_by_inserted!/1","title":"Rivet.Ident.Handle.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count_by_updated!/0","title":"Rivet.Ident.Handle.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#count_by_updated!/1","title":"Rivet.Ident.Handle.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#create/1","title":"Rivet.Ident.Handle.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Handle.html#create_post/2","title":"Rivet.Ident.Handle.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Handle.html#create_prep/2","title":"Rivet.Ident.Handle.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#delete/1","title":"Rivet.Ident.Handle.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#delete_all/2","title":"Rivet.Ident.Handle.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#delete_all_ids/2","title":"Rivet.Ident.Handle.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#drop_replace/2","title":"Rivet.Ident.Handle.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#exists?/1","title":"Rivet.Ident.Handle.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#full_table_scan/2","title":"Rivet.Ident.Handle.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#insert/2","title":"Rivet.Ident.Handle.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#latest/2","title":"Rivet.Ident.Handle.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#latest!/2","title":"Rivet.Ident.Handle.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#one/2","title":"Rivet.Ident.Handle.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#one!/2","title":"Rivet.Ident.Handle.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#preload/3","title":"Rivet.Ident.Handle.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#preload!/3","title":"Rivet.Ident.Handle.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#replace/2","title":"Rivet.Ident.Handle.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Handle.html#replace_fill/2","title":"Rivet.Ident.Handle.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#stream/2","title":"Rivet.Ident.Handle.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#stream_all!/2","title":"Rivet.Ident.Handle.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Handle.html#touch/1","title":"Rivet.Ident.Handle.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#unload/1","title":"Rivet.Ident.Handle.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#unload/2","title":"Rivet.Ident.Handle.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#update/2","title":"Rivet.Ident.Handle.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#update!/2","title":"Rivet.Ident.Handle.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#update_all/2","title":"Rivet.Ident.Handle.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#update_fill/2","title":"Rivet.Ident.Handle.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#upsert/2","title":"Rivet.Ident.Handle.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.html#t:ecto_p_result/0","title":"Rivet.Ident.Handle.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Handle.html#t:id/0","title":"Rivet.Ident.Handle.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Handle.html#t:model_p_result/0","title":"Rivet.Ident.Handle.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Handle.html#t:t/0","title":"Rivet.Ident.Handle.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Handle.Lib.html","title":"Rivet.Ident.Handle.Lib","type":"module"},{"doc":"Check if handle is open, return double-error (internal/external msg)","ref":"Rivet.Ident.Handle.Lib.html#available/2","title":"Rivet.Ident.Handle.Lib.available/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.Lib.html#gen_good_handle/1","title":"Rivet.Ident.Handle.Lib.gen_good_handle/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Handle.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Handle.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Handle.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Handle.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.html","title":"Rivet.Ident.Phone","type":"module"},{"doc":"","ref":"Rivet.Ident.Phone.html#aggregate/2","title":"Rivet.Ident.Phone.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#all/2","title":"Rivet.Ident.Phone.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#all!/2","title":"Rivet.Ident.Phone.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#associate/3","title":"Rivet.Ident.Phone.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#build/1","title":"Rivet.Ident.Phone.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Phone.html#change_post/2","title":"Rivet.Ident.Phone.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Phone.html#change_prep/2","title":"Rivet.Ident.Phone.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#changeset/2","title":"Rivet.Ident.Phone.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count!/0","title":"Rivet.Ident.Phone.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count!/1","title":"Rivet.Ident.Phone.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count_by_inserted!/0","title":"Rivet.Ident.Phone.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count_by_inserted!/1","title":"Rivet.Ident.Phone.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count_by_updated!/0","title":"Rivet.Ident.Phone.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#count_by_updated!/1","title":"Rivet.Ident.Phone.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#create/1","title":"Rivet.Ident.Phone.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Phone.html#create_post/2","title":"Rivet.Ident.Phone.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Phone.html#create_prep/2","title":"Rivet.Ident.Phone.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#delete/1","title":"Rivet.Ident.Phone.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#delete_all/2","title":"Rivet.Ident.Phone.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#delete_all_ids/2","title":"Rivet.Ident.Phone.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#drop_replace/2","title":"Rivet.Ident.Phone.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#exists?/1","title":"Rivet.Ident.Phone.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#full_table_scan/2","title":"Rivet.Ident.Phone.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#insert/2","title":"Rivet.Ident.Phone.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#latest/2","title":"Rivet.Ident.Phone.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#latest!/2","title":"Rivet.Ident.Phone.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#one/2","title":"Rivet.Ident.Phone.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#one!/2","title":"Rivet.Ident.Phone.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#preload/3","title":"Rivet.Ident.Phone.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#preload!/3","title":"Rivet.Ident.Phone.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#replace/2","title":"Rivet.Ident.Phone.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Phone.html#replace_fill/2","title":"Rivet.Ident.Phone.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#stream/2","title":"Rivet.Ident.Phone.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#stream_all!/2","title":"Rivet.Ident.Phone.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Phone.html#touch/1","title":"Rivet.Ident.Phone.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#unload/1","title":"Rivet.Ident.Phone.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#unload/2","title":"Rivet.Ident.Phone.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#update/2","title":"Rivet.Ident.Phone.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#update!/2","title":"Rivet.Ident.Phone.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#update_all/2","title":"Rivet.Ident.Phone.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#update_fill/2","title":"Rivet.Ident.Phone.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#upsert/2","title":"Rivet.Ident.Phone.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#validate/1","title":"Rivet.Ident.Phone.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Phone.html#t:ecto_p_result/0","title":"Rivet.Ident.Phone.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.html#t:id/0","title":"Rivet.Ident.Phone.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.html#t:model_p_result/0","title":"Rivet.Ident.Phone.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.html#t:t/0","title":"Rivet.Ident.Phone.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.Lib.html","title":"Rivet.Ident.Phone.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Phone.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Phone.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Phone.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Phone.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.html","title":"Rivet.Ident.Role","type":"module"},{"doc":"","ref":"Rivet.Ident.Role.html#aggregate/2","title":"Rivet.Ident.Role.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#all/2","title":"Rivet.Ident.Role.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#all!/2","title":"Rivet.Ident.Role.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#associate/3","title":"Rivet.Ident.Role.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#build/1","title":"Rivet.Ident.Role.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Role.html#change_post/2","title":"Rivet.Ident.Role.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Role.html#change_prep/2","title":"Rivet.Ident.Role.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#changeset/2","title":"Rivet.Ident.Role.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count!/0","title":"Rivet.Ident.Role.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count!/1","title":"Rivet.Ident.Role.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count_by_inserted!/0","title":"Rivet.Ident.Role.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count_by_inserted!/1","title":"Rivet.Ident.Role.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count_by_updated!/0","title":"Rivet.Ident.Role.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#count_by_updated!/1","title":"Rivet.Ident.Role.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#create/1","title":"Rivet.Ident.Role.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.Role.html#create_post/2","title":"Rivet.Ident.Role.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.Role.html#create_prep/2","title":"Rivet.Ident.Role.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#delete/1","title":"Rivet.Ident.Role.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#delete_all/2","title":"Rivet.Ident.Role.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#delete_all_ids/2","title":"Rivet.Ident.Role.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#drop_replace/2","title":"Rivet.Ident.Role.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#exists?/1","title":"Rivet.Ident.Role.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#full_table_scan/2","title":"Rivet.Ident.Role.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#insert/2","title":"Rivet.Ident.Role.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#latest/2","title":"Rivet.Ident.Role.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#latest!/2","title":"Rivet.Ident.Role.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#one/2","title":"Rivet.Ident.Role.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#one!/2","title":"Rivet.Ident.Role.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#preload/3","title":"Rivet.Ident.Role.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#preload!/3","title":"Rivet.Ident.Role.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#replace/2","title":"Rivet.Ident.Role.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.Role.html#replace_fill/2","title":"Rivet.Ident.Role.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#stream/2","title":"Rivet.Ident.Role.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#stream_all!/2","title":"Rivet.Ident.Role.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.Role.html#touch/1","title":"Rivet.Ident.Role.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#unload/1","title":"Rivet.Ident.Role.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#unload/2","title":"Rivet.Ident.Role.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#update/2","title":"Rivet.Ident.Role.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#update!/2","title":"Rivet.Ident.Role.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#update_all/2","title":"Rivet.Ident.Role.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#update_fill/2","title":"Rivet.Ident.Role.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#upsert/2","title":"Rivet.Ident.Role.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#validate/1","title":"Rivet.Ident.Role.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.html#t:ecto_p_result/0","title":"Rivet.Ident.Role.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.html#t:id/0","title":"Rivet.Ident.Role.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.html#t:model_p_result/0","title":"Rivet.Ident.Role.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.html#t:t/0","title":"Rivet.Ident.Role.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.Cache.html","title":"Rivet.Ident.Role.Cache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Rivet.Ident.Role.Cache.html#child_spec/1","title":"Rivet.Ident.Role.Cache.child_spec/1","type":"function"},{"doc":"Delete everything in the cache. Returns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.Role.Cache.html#clear/0","title":"Rivet.Ident.Role.Cache.clear/0","type":"function"},{"doc":"Delete anything by its key. Returns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.Role.Cache.html#delete/1","title":"Rivet.Ident.Role.Cache.delete/1","type":"function"},{"doc":"Store anything for a certain amount of time or forever if no keep alive time specified Returns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.Role.Cache.html#insert/3","title":"Rivet.Ident.Role.Cache.insert/3","type":"function"},{"doc":"Retrieve anything by its key. Returns [{your_stored_tuple}] .","ref":"Rivet.Ident.Role.Cache.html#lookup/1","title":"Rivet.Ident.Role.Cache.lookup/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.Cache.html#purge_cache/0","title":"Rivet.Ident.Role.Cache.purge_cache/0","type":"function"},{"doc":"Obtain the number of elements stored in the cache. Returns an integer equals or bigger than zero.","ref":"Rivet.Ident.Role.Cache.html#size/0","title":"Rivet.Ident.Role.Cache.size/0","type":"function"},{"doc":"Start scheduling the works for clearing the cache. This method should be called before performing any operation. Returns {:ok, PID} .","ref":"Rivet.Ident.Role.Cache.html#start_link/1","title":"Rivet.Ident.Role.Cache.start_link/1","type":"function"},{"doc":"","ref":"Rivet.Ident.Role.Lib.html","title":"Rivet.Ident.Role.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.Role.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.Role.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.Role.Lib.html#t:model_p_result/0","title":"Rivet.Ident.Role.Lib.model_p_result/0","type":"type"},{"doc":"Schema for representing and working with a Ident.RoleMap.","ref":"Rivet.Ident.RoleMap.html","title":"Rivet.Ident.RoleMap","type":"module"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#aggregate/2","title":"Rivet.Ident.RoleMap.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#all/2","title":"Rivet.Ident.RoleMap.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#all!/2","title":"Rivet.Ident.RoleMap.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#associate/3","title":"Rivet.Ident.RoleMap.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#build/1","title":"Rivet.Ident.RoleMap.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.RoleMap.html#change_post/2","title":"Rivet.Ident.RoleMap.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.RoleMap.html#change_prep/2","title":"Rivet.Ident.RoleMap.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#changeset/2","title":"Rivet.Ident.RoleMap.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count!/0","title":"Rivet.Ident.RoleMap.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count!/1","title":"Rivet.Ident.RoleMap.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_inserted!/0","title":"Rivet.Ident.RoleMap.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_inserted!/1","title":"Rivet.Ident.RoleMap.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_updated!/0","title":"Rivet.Ident.RoleMap.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#count_by_updated!/1","title":"Rivet.Ident.RoleMap.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#create/1","title":"Rivet.Ident.RoleMap.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.RoleMap.html#create_post/2","title":"Rivet.Ident.RoleMap.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.RoleMap.html#create_prep/2","title":"Rivet.Ident.RoleMap.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#delete/1","title":"Rivet.Ident.RoleMap.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#delete_all/2","title":"Rivet.Ident.RoleMap.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#delete_all_ids/2","title":"Rivet.Ident.RoleMap.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#drop_replace/2","title":"Rivet.Ident.RoleMap.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#exists?/1","title":"Rivet.Ident.RoleMap.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#full_table_scan/2","title":"Rivet.Ident.RoleMap.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#insert/2","title":"Rivet.Ident.RoleMap.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#latest/2","title":"Rivet.Ident.RoleMap.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#latest!/2","title":"Rivet.Ident.RoleMap.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#one/2","title":"Rivet.Ident.RoleMap.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#one!/2","title":"Rivet.Ident.RoleMap.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#preload/3","title":"Rivet.Ident.RoleMap.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#preload!/3","title":"Rivet.Ident.RoleMap.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#replace/2","title":"Rivet.Ident.RoleMap.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.RoleMap.html#replace_fill/2","title":"Rivet.Ident.RoleMap.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#stream/2","title":"Rivet.Ident.RoleMap.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#stream_all!/2","title":"Rivet.Ident.RoleMap.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.RoleMap.html#touch/1","title":"Rivet.Ident.RoleMap.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#unload/1","title":"Rivet.Ident.RoleMap.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#unload/2","title":"Rivet.Ident.RoleMap.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#update/2","title":"Rivet.Ident.RoleMap.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#update!/2","title":"Rivet.Ident.RoleMap.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#update_all/2","title":"Rivet.Ident.RoleMap.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#update_fill/2","title":"Rivet.Ident.RoleMap.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#upsert/2","title":"Rivet.Ident.RoleMap.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#validate/1","title":"Rivet.Ident.RoleMap.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#t:ecto_p_result/0","title":"Rivet.Ident.RoleMap.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#t:id/0","title":"Rivet.Ident.RoleMap.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#t:model_p_result/0","title":"Rivet.Ident.RoleMap.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.RoleMap.html#t:t/0","title":"Rivet.Ident.RoleMap.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html","title":"Rivet.Ident.RoleMap.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#get_actions/1","title":"Rivet.Ident.RoleMap.Lib.get_actions/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#get_actions/3","title":"Rivet.Ident.RoleMap.Lib.get_actions/3","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#map_actions/1","title":"Rivet.Ident.RoleMap.Lib.map_actions/1","type":"function"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.RoleMap.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.RoleMap.Lib.html#t:model_p_result/0","title":"Rivet.Ident.RoleMap.Lib.model_p_result/0","type":"type"},{"doc":"Schema for representing and working with a Ident.User.","ref":"Rivet.Ident.User.html","title":"Rivet.Ident.User","type":"module"},{"doc":"","ref":"Rivet.Ident.User.html#aggregate/2","title":"Rivet.Ident.User.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#all/2","title":"Rivet.Ident.User.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#all!/2","title":"Rivet.Ident.User.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#associate/3","title":"Rivet.Ident.User.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#build/1","title":"Rivet.Ident.User.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.User.html#change_post/2","title":"Rivet.Ident.User.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.User.html#change_prep/2","title":"Rivet.Ident.User.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#changeset/2","title":"Rivet.Ident.User.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count!/0","title":"Rivet.Ident.User.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count!/1","title":"Rivet.Ident.User.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count_by_inserted!/0","title":"Rivet.Ident.User.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count_by_inserted!/1","title":"Rivet.Ident.User.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count_by_updated!/0","title":"Rivet.Ident.User.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#count_by_updated!/1","title":"Rivet.Ident.User.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#create/1","title":"Rivet.Ident.User.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.User.html#create_post/2","title":"Rivet.Ident.User.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.User.html#create_prep/2","title":"Rivet.Ident.User.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#delete/1","title":"Rivet.Ident.User.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#delete_all/2","title":"Rivet.Ident.User.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#delete_all_ids/2","title":"Rivet.Ident.User.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#drop_replace/2","title":"Rivet.Ident.User.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#enabled?/1","title":"Rivet.Ident.User.enabled?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#exists?/1","title":"Rivet.Ident.User.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#full_table_scan/2","title":"Rivet.Ident.User.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#insert/2","title":"Rivet.Ident.User.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#latest/2","title":"Rivet.Ident.User.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#latest!/2","title":"Rivet.Ident.User.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#one/2","title":"Rivet.Ident.User.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#one!/2","title":"Rivet.Ident.User.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#preload/3","title":"Rivet.Ident.User.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#preload!/3","title":"Rivet.Ident.User.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#replace/2","title":"Rivet.Ident.User.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.User.html#replace_fill/2","title":"Rivet.Ident.User.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#stream/2","title":"Rivet.Ident.User.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#stream_all!/2","title":"Rivet.Ident.User.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.User.html#touch/1","title":"Rivet.Ident.User.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#unload/1","title":"Rivet.Ident.User.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#unload/2","title":"Rivet.Ident.User.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#update/2","title":"Rivet.Ident.User.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#update!/2","title":"Rivet.Ident.User.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#update_all/2","title":"Rivet.Ident.User.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#update_fill/2","title":"Rivet.Ident.User.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#upsert/2","title":"Rivet.Ident.User.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#validate/1","title":"Rivet.Ident.User.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.html#t:ecto_p_result/0","title":"Rivet.Ident.User.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.User.html#t:id/0","title":"Rivet.Ident.User.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.User.html#t:model_p_result/0","title":"Rivet.Ident.User.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.User.html#t:t/0","title":"Rivet.Ident.User.t/0","type":"type"},{"doc":"Used by websockets token authentication. Very short term cache to efficiently load ~30 websockets all at once for a single dashboard.","ref":"Rivet.Ident.User.Cache.html","title":"Rivet.Ident.User.Cache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Rivet.Ident.User.Cache.html#child_spec/1","title":"Rivet.Ident.User.Cache.child_spec/1","type":"function"},{"doc":"Delete everything in the cache. Returns a boolean indicating if cache has been correctly cleared.","ref":"Rivet.Ident.User.Cache.html#clear/0","title":"Rivet.Ident.User.Cache.clear/0","type":"function"},{"doc":"Delete anything by its key. Returns a boolean indicating if element has been correctly deleted.","ref":"Rivet.Ident.User.Cache.html#delete/1","title":"Rivet.Ident.User.Cache.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Cache.html#get_user/1","title":"Rivet.Ident.User.Cache.get_user/1","type":"function"},{"doc":"Store anything for a certain amount of time or forever if no keep alive time specified Returns a boolean indicating if element has been correctly inserted.","ref":"Rivet.Ident.User.Cache.html#insert/3","title":"Rivet.Ident.User.Cache.insert/3","type":"function"},{"doc":"Retrieve anything by its key. Returns [{your_stored_tuple}] .","ref":"Rivet.Ident.User.Cache.html#lookup/1","title":"Rivet.Ident.User.Cache.lookup/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Cache.html#persist/1","title":"Rivet.Ident.User.Cache.persist/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Cache.html#purge_cache/0","title":"Rivet.Ident.User.Cache.purge_cache/0","type":"function"},{"doc":"Obtain the number of elements stored in the cache. Returns an integer equals or bigger than zero.","ref":"Rivet.Ident.User.Cache.html#size/0","title":"Rivet.Ident.User.Cache.size/0","type":"function"},{"doc":"Start scheduling the works for clearing the cache. This method should be called before performing any operation. Returns {:ok, PID} .","ref":"Rivet.Ident.User.Cache.html#start_link/1","title":"Rivet.Ident.User.Cache.start_link/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html","title":"Rivet.Ident.User.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#add_email/3","title":"Rivet.Ident.User.Lib.add_email/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#add_phone/2","title":"Rivet.Ident.User.Lib.add_phone/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#all_since/1","title":"Rivet.Ident.User.Lib.all_since/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#check_authz/2","title":"Rivet.Ident.User.Lib.check_authz/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#check_user_status/1","title":"Rivet.Ident.User.Lib.check_user_status/1","type":"function"},{"doc":"Bring in the list of authorized actions onto the user object (into :authz) Only load once, if authz is nil","ref":"Rivet.Ident.User.Lib.html#get_authz/1","title":"Rivet.Ident.User.Lib.get_authz/1","type":"function"},{"doc":"iex&gt; get_user(&quot;asdf&quot;) iex&gt; get_user(&quot;A73DD874-A724-494F-B9E2-2042A4383144&quot;) iex&gt; handle = insert(:ident_handle) ...&gt; {:ok, u} = get_user(handle.user_id) ...&gt; u.id handle.user_id iex&gt; handle = insert(:ident_handle) ...&gt; {:ok, u} = get_user(handle.handle, [:handle]) ...&gt; u.id handle.user_id","ref":"Rivet.Ident.User.Lib.html#get_user/2","title":"Rivet.Ident.User.Lib.get_user/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#get_user_by_handle/2","title":"Rivet.Ident.User.Lib.get_user_by_handle/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#has_other_admin?/2","title":"Rivet.Ident.User.Lib.has_other_admin?/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#search/2","title":"Rivet.Ident.User.Lib.search/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#search_name!/1","title":"Rivet.Ident.User.Lib.search_name!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#user_seen/1","title":"Rivet.Ident.User.Lib.user_seen/1","type":"function"},{"doc":"Helper function which accepts either user_id or user, and calls the passed function with the user model loaded including any preloads. Send preloads as [] if none are desired.","ref":"Rivet.Ident.User.Lib.html#with_user/3","title":"Rivet.Ident.User.Lib.with_user/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.User.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.User.Lib.html#t:model_p_result/0","title":"Rivet.Ident.User.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.User.Lib.Signup.html","title":"Rivet.Ident.User.Lib.Signup","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#add_email/3","title":"Rivet.Ident.User.Lib.Signup.add_email/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#add_phone/2","title":"Rivet.Ident.User.Lib.Signup.add_phone/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.Signup.html#only_identity/1","title":"Rivet.Ident.User.Lib.Signup.only_identity/1","type":"function"},{"doc":"SignUp pipeline","ref":"Rivet.Ident.User.Lib.Signup.html#signup/1","title":"Rivet.Ident.User.Lib.Signup.signup/1","type":"function"},{"doc":"Making changes to a user (administratively or as the user). See UsersUpdate.update @spec for details on args. Explains for said args: user_changes map is variable, in that it's keys may vary based on the input args sent into GraphQL updatePerson() mutation caller_authz is the level of authorization for the caller, which changes what updates are allowed. target_user is optional, if nil the user should be created, if exists then it's an update for that user Example (create): == &gt; Rivet.Ident.UsersUpdate . update ( %{ action : :upsert , user : %{ name : &quot;The Doctor&quot; } , email : %{ email : &quot;who@tardis.com&quot; } } , :admin ) { :ok , % User { } , %{ &quot;password&quot; : &quot;R^EkW)aBY9G9&quot; , &quot;passwordExp&quot; : 1649947803 } } Rivet.Ident.UsersUpdate.update(%{ action: :upsert, user: %{name: &quot;The Doctor&quot;}, email: %{email: &quot;who@tardis.com&quot;} }, :admin) Example — update a user's name as the user == &gt; Rivet.Ident.UsersUpdate . update ( %{ action : :upsert , user : %{ name : &quot;Who&quot; } , } , :user , % User { ... } ) { :ok , % User { } , %{ } } Example — remove a phone == &gt; Rivet.Ident.UsersUpdate . update ( %{ action : :remove , phone : %{ id : &quot;2342343-...-33&quot; } , } , :user , % User { ... } ) { :ok , % User { } , %{ } }","ref":"Rivet.Ident.User.Lib.Update.html","title":"Rivet.Ident.User.Lib.Update","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Lib.Update.html#preflight_user_create/1","title":"Rivet.Ident.User.Lib.Update.preflight_user_create/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Lib.Update.html#update/3","title":"Rivet.Ident.User.Lib.Update.update/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html","title":"Rivet.Ident.User.Notify.FailedChange","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html#eval/3","title":"Rivet.Ident.User.Notify.FailedChange.eval/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.FailedChange.html#load_and_eval/2","title":"Rivet.Ident.User.Notify.FailedChange.load_and_eval/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html","title":"Rivet.Ident.User.Notify.PasswordChanged","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#eval/3","title":"Rivet.Ident.User.Notify.PasswordChanged.eval/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#load_and_eval/2","title":"Rivet.Ident.User.Notify.PasswordChanged.load_and_eval/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordChanged.html#send/1","title":"Rivet.Ident.User.Notify.PasswordChanged.send/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html","title":"Rivet.Ident.User.Notify.PasswordReset","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#eval/3","title":"Rivet.Ident.User.Notify.PasswordReset.eval/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#load_and_eval/2","title":"Rivet.Ident.User.Notify.PasswordReset.load_and_eval/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.PasswordReset.html#send/3","title":"Rivet.Ident.User.Notify.PasswordReset.send/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.Verification.html","title":"Rivet.Ident.User.Notify.Verification","type":"module"},{"doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#eval/3","title":"Rivet.Ident.User.Notify.Verification.eval/3","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#load_and_eval/2","title":"Rivet.Ident.User.Notify.Verification.load_and_eval/2","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Notify.Verification.html#send/1","title":"Rivet.Ident.User.Notify.Verification.send/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.html","title":"Rivet.Ident.User.PasswordGenerator","type":"module"},{"doc":"Generate random password Example defmodule ( Passwd , do : use ( RandomPassword , alpha : 16 , decimal : 4 , symbol : 2 ) ) Passwd . generate ( ) &quot;vwt8FauEN+spr5{m1Rhso7&quot;","ref":"Rivet.Ident.User.PasswordGenerator.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.generate/0","type":"function"},{"doc":"RandomPassword generated module info. Example defmodule ( Password , do : use ( RandomPassword , alpha : 16 , decimal : 2 , symbol : 1 ) ) Password . info ( ) % RandomPassword.Info { alpha : 16 , decimal : 2 , entropy_bits : 102.66 , symbol : 1 , symbols : &quot;!#$%&amp;()*+,-./:;&lt;=&gt;?@[]^_{|}~&quot; }","ref":"Rivet.Ident.User.PasswordGenerator.html#info/0","title":"Rivet.Ident.User.PasswordGenerator.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html","title":"Rivet.Ident.User.PasswordGenerator.Alpha","type":"module"},{"doc":"Generate a puid","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Alpha.generate/0","type":"function"},{"doc":"Puid.Info module info","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.html#info/0","title":"Rivet.Ident.User.PasswordGenerator.Alpha.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.html#reset/0","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Bits.reset/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.html","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.html#encode/1","title":"Rivet.Ident.User.PasswordGenerator.Alpha.Encoding.encode/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html","title":"Rivet.Ident.User.PasswordGenerator.Decimal","type":"module"},{"doc":"Generate a puid","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Decimal.generate/0","type":"function"},{"doc":"Puid.Info module info","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.html#info/0","title":"Rivet.Ident.User.PasswordGenerator.Decimal.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.html#reset/0","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Bits.reset/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.html","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.html#encode/1","title":"Rivet.Ident.User.PasswordGenerator.Decimal.Encoding.encode/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html","title":"Rivet.Ident.User.PasswordGenerator.Empty","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Empty.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Empty.html#info/0","title":"Rivet.Ident.User.PasswordGenerator.Empty.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html","title":"Rivet.Ident.User.PasswordGenerator.Symbol","type":"module"},{"doc":"Generate a puid","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Symbol.generate/0","type":"function"},{"doc":"Puid.Info module info","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.html#info/0","title":"Rivet.Ident.User.PasswordGenerator.Symbol.info/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html#generate/0","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.generate/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.html#reset/0","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Bits.reset/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.html","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding","type":"module"},{"doc":"","ref":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.html#encode/1","title":"Rivet.Ident.User.PasswordGenerator.Symbol.Encoding.encode/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Types.html","title":"Rivet.Ident.User.Types","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Rivet.Ident.User.Types.html#cast/1","title":"Rivet.Ident.User.Types.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Rivet.Ident.User.Types.html#dump/1","title":"Rivet.Ident.User.Types.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Rivet.Ident.User.Types.html#embed_as/1","title":"Rivet.Ident.User.Types.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Rivet.Ident.User.Types.html#equal?/2","title":"Rivet.Ident.User.Types.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Rivet.Ident.User.Types.html#load/1","title":"Rivet.Ident.User.Types.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Rivet.Ident.User.Types.html#type/0","title":"Rivet.Ident.User.Types.type/0","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Types.html#valid_value?/1","title":"Rivet.Ident.User.Types.valid_value?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.User.Types.html#t:t/0","title":"Rivet.Ident.User.Types.t/0","type":"type"},{"doc":"Schema for representing and working with a Ident.UserCode.","ref":"Rivet.Ident.UserCode.html","title":"Rivet.Ident.UserCode","type":"module"},{"doc":"","ref":"Rivet.Ident.UserCode.html#aggregate/2","title":"Rivet.Ident.UserCode.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#all/2","title":"Rivet.Ident.UserCode.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#all!/2","title":"Rivet.Ident.UserCode.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#associate/3","title":"Rivet.Ident.UserCode.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#build/1","title":"Rivet.Ident.UserCode.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserCode.html#change_post/2","title":"Rivet.Ident.UserCode.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserCode.html#change_prep/2","title":"Rivet.Ident.UserCode.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#changeset/2","title":"Rivet.Ident.UserCode.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count!/0","title":"Rivet.Ident.UserCode.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count!/1","title":"Rivet.Ident.UserCode.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count_by_inserted!/0","title":"Rivet.Ident.UserCode.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count_by_inserted!/1","title":"Rivet.Ident.UserCode.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count_by_updated!/0","title":"Rivet.Ident.UserCode.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#count_by_updated!/1","title":"Rivet.Ident.UserCode.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#create/1","title":"Rivet.Ident.UserCode.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserCode.html#create_post/2","title":"Rivet.Ident.UserCode.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserCode.html#create_prep/2","title":"Rivet.Ident.UserCode.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#delete/1","title":"Rivet.Ident.UserCode.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#delete_all/2","title":"Rivet.Ident.UserCode.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#delete_all_ids/2","title":"Rivet.Ident.UserCode.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#drop_replace/2","title":"Rivet.Ident.UserCode.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#exists?/1","title":"Rivet.Ident.UserCode.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#full_table_scan/2","title":"Rivet.Ident.UserCode.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#insert/2","title":"Rivet.Ident.UserCode.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#latest/2","title":"Rivet.Ident.UserCode.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#latest!/2","title":"Rivet.Ident.UserCode.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#one/2","title":"Rivet.Ident.UserCode.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#one!/2","title":"Rivet.Ident.UserCode.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#preload/3","title":"Rivet.Ident.UserCode.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#preload!/3","title":"Rivet.Ident.UserCode.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#replace/2","title":"Rivet.Ident.UserCode.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserCode.html#replace_fill/2","title":"Rivet.Ident.UserCode.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#stream/2","title":"Rivet.Ident.UserCode.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#stream_all!/2","title":"Rivet.Ident.UserCode.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.UserCode.html#touch/1","title":"Rivet.Ident.UserCode.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#unload/1","title":"Rivet.Ident.UserCode.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#unload/2","title":"Rivet.Ident.UserCode.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#update/2","title":"Rivet.Ident.UserCode.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#update!/2","title":"Rivet.Ident.UserCode.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#update_all/2","title":"Rivet.Ident.UserCode.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#update_fill/2","title":"Rivet.Ident.UserCode.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#upsert/2","title":"Rivet.Ident.UserCode.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#validate/1","title":"Rivet.Ident.UserCode.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.html#t:ecto_p_result/0","title":"Rivet.Ident.UserCode.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserCode.html#t:id/0","title":"Rivet.Ident.UserCode.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserCode.html#t:model_p_result/0","title":"Rivet.Ident.UserCode.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserCode.html#t:t/0","title":"Rivet.Ident.UserCode.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html","title":"Rivet.Ident.UserCode.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html#clear_all_codes/2","title":"Rivet.Ident.UserCode.Lib.clear_all_codes/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html#clear_expired_codes/0","title":"Rivet.Ident.UserCode.Lib.clear_expired_codes/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html#generate_code/4","title":"Rivet.Ident.UserCode.Lib.generate_code/4","type":"function"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.UserCode.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserCode.Lib.html#t:model_p_result/0","title":"Rivet.Ident.UserCode.Lib.model_p_result/0","type":"type"},{"doc":"Schema for representing and working with a Ident.UserData.","ref":"Rivet.Ident.UserData.html","title":"Rivet.Ident.UserData","type":"module"},{"doc":"","ref":"Rivet.Ident.UserData.html#aggregate/2","title":"Rivet.Ident.UserData.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#all/2","title":"Rivet.Ident.UserData.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#all!/2","title":"Rivet.Ident.UserData.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#associate/3","title":"Rivet.Ident.UserData.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#build/1","title":"Rivet.Ident.UserData.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserData.html#change_post/2","title":"Rivet.Ident.UserData.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserData.html#change_prep/2","title":"Rivet.Ident.UserData.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#changeset/2","title":"Rivet.Ident.UserData.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count!/0","title":"Rivet.Ident.UserData.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count!/1","title":"Rivet.Ident.UserData.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count_by_inserted!/0","title":"Rivet.Ident.UserData.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count_by_inserted!/1","title":"Rivet.Ident.UserData.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count_by_updated!/0","title":"Rivet.Ident.UserData.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#count_by_updated!/1","title":"Rivet.Ident.UserData.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#create/1","title":"Rivet.Ident.UserData.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserData.html#create_post/2","title":"Rivet.Ident.UserData.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserData.html#create_prep/2","title":"Rivet.Ident.UserData.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#delete/1","title":"Rivet.Ident.UserData.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#delete_all/2","title":"Rivet.Ident.UserData.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#delete_all_ids/2","title":"Rivet.Ident.UserData.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#drop_replace/2","title":"Rivet.Ident.UserData.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#exists?/1","title":"Rivet.Ident.UserData.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#full_table_scan/2","title":"Rivet.Ident.UserData.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#insert/2","title":"Rivet.Ident.UserData.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#latest/2","title":"Rivet.Ident.UserData.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#latest!/2","title":"Rivet.Ident.UserData.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#one/2","title":"Rivet.Ident.UserData.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#one!/2","title":"Rivet.Ident.UserData.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#preload/3","title":"Rivet.Ident.UserData.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#preload!/3","title":"Rivet.Ident.UserData.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#replace/2","title":"Rivet.Ident.UserData.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserData.html#replace_fill/2","title":"Rivet.Ident.UserData.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#stream/2","title":"Rivet.Ident.UserData.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#stream_all!/2","title":"Rivet.Ident.UserData.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.UserData.html#touch/1","title":"Rivet.Ident.UserData.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#unload/1","title":"Rivet.Ident.UserData.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#unload/2","title":"Rivet.Ident.UserData.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#update/2","title":"Rivet.Ident.UserData.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#update!/2","title":"Rivet.Ident.UserData.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#update_all/2","title":"Rivet.Ident.UserData.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#update_fill/2","title":"Rivet.Ident.UserData.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#upsert/2","title":"Rivet.Ident.UserData.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#validate/1","title":"Rivet.Ident.UserData.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.html#t:ecto_p_result/0","title":"Rivet.Ident.UserData.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.html#t:id/0","title":"Rivet.Ident.UserData.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.html#t:model_p_result/0","title":"Rivet.Ident.UserData.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.html#t:t/0","title":"Rivet.Ident.UserData.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.Lib.html","title":"Rivet.Ident.UserData.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.UserData.Lib.html#list_types/2","title":"Rivet.Ident.UserData.Lib.list_types/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.UserData.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.Lib.html#t:model_p_result/0","title":"Rivet.Ident.UserData.Lib.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserData.Types.html","title":"Rivet.Ident.UserData.Types","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Rivet.Ident.UserData.Types.html#cast/1","title":"Rivet.Ident.UserData.Types.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Rivet.Ident.UserData.Types.html#dump/1","title":"Rivet.Ident.UserData.Types.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Rivet.Ident.UserData.Types.html#embed_as/1","title":"Rivet.Ident.UserData.Types.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Rivet.Ident.UserData.Types.html#equal?/2","title":"Rivet.Ident.UserData.Types.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Rivet.Ident.UserData.Types.html#load/1","title":"Rivet.Ident.UserData.Types.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Rivet.Ident.UserData.Types.html#type/0","title":"Rivet.Ident.UserData.Types.type/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.Types.html#valid_value?/1","title":"Rivet.Ident.UserData.Types.valid_value?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserData.Types.html#t:t/0","title":"Rivet.Ident.UserData.Types.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.html","title":"Rivet.Ident.UserIdent","type":"module"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#aggregate/2","title":"Rivet.Ident.UserIdent.aggregate/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#all/2","title":"Rivet.Ident.UserIdent.all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#all!/2","title":"Rivet.Ident.UserIdent.all!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#associate/3","title":"Rivet.Ident.UserIdent.associate/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#build/1","title":"Rivet.Ident.UserIdent.build/1","type":"function"},{"doc":"change_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserIdent.html#change_post/2","title":"Rivet.Ident.UserIdent.change_post/2","type":"function"},{"doc":"change_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserIdent.html#change_prep/2","title":"Rivet.Ident.UserIdent.change_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#changeset/2","title":"Rivet.Ident.UserIdent.changeset/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count!/0","title":"Rivet.Ident.UserIdent.count!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count!/1","title":"Rivet.Ident.UserIdent.count!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_inserted!/0","title":"Rivet.Ident.UserIdent.count_by_inserted!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_inserted!/1","title":"Rivet.Ident.UserIdent.count_by_inserted!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_updated!/0","title":"Rivet.Ident.UserIdent.count_by_updated!/0","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#count_by_updated!/1","title":"Rivet.Ident.UserIdent.count_by_updated!/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#create/1","title":"Rivet.Ident.UserIdent.create/1","type":"function"},{"doc":"create_post for side effects; should return the item Note: BE VERY CAREFUL on large impact effects. This can quickly become a performance bottleneck.","ref":"Rivet.Ident.UserIdent.html#create_post/2","title":"Rivet.Ident.UserIdent.create_post/2","type":"function"},{"doc":"create_prep alters the params only, and may only return {:ok, params}","ref":"Rivet.Ident.UserIdent.html#create_prep/2","title":"Rivet.Ident.UserIdent.create_prep/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#delete/1","title":"Rivet.Ident.UserIdent.delete/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#delete_all/2","title":"Rivet.Ident.UserIdent.delete_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#delete_all_ids/2","title":"Rivet.Ident.UserIdent.delete_all_ids/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#drop_replace/2","title":"Rivet.Ident.UserIdent.drop_replace/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#exists?/1","title":"Rivet.Ident.UserIdent.exists?/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#full_table_scan/2","title":"Rivet.Ident.UserIdent.full_table_scan/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#insert/2","title":"Rivet.Ident.UserIdent.insert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#latest/2","title":"Rivet.Ident.UserIdent.latest/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#latest!/2","title":"Rivet.Ident.UserIdent.latest!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#one/2","title":"Rivet.Ident.UserIdent.one/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#one!/2","title":"Rivet.Ident.UserIdent.one!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#preload/3","title":"Rivet.Ident.UserIdent.preload/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#preload!/3","title":"Rivet.Ident.UserIdent.preload!/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#replace/2","title":"Rivet.Ident.UserIdent.replace/2","type":"function"},{"doc":"Similar to replace, but it doesn't remove existing values if the attrs has nil","ref":"Rivet.Ident.UserIdent.html#replace_fill/2","title":"Rivet.Ident.UserIdent.replace_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#stream/2","title":"Rivet.Ident.UserIdent.stream/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#stream_all!/2","title":"Rivet.Ident.UserIdent.stream_all!/2","type":"function"},{"doc":"Update our updated_at but only if it hasn't changed within a minute (less load)","ref":"Rivet.Ident.UserIdent.html#touch/1","title":"Rivet.Ident.UserIdent.touch/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#unload/1","title":"Rivet.Ident.UserIdent.unload/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#unload/2","title":"Rivet.Ident.UserIdent.unload/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#update/2","title":"Rivet.Ident.UserIdent.update/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#update!/2","title":"Rivet.Ident.UserIdent.update!/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#update_all/2","title":"Rivet.Ident.UserIdent.update_all/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#update_fill/2","title":"Rivet.Ident.UserIdent.update_fill/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#upsert/2","title":"Rivet.Ident.UserIdent.upsert/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#validate/1","title":"Rivet.Ident.UserIdent.validate/1","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#t:ecto_p_result/0","title":"Rivet.Ident.UserIdent.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#t:id/0","title":"Rivet.Ident.UserIdent.id/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#t:model_p_result/0","title":"Rivet.Ident.UserIdent.model_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.html#t:t/0","title":"Rivet.Ident.UserIdent.t/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.Lib.html","title":"Rivet.Ident.UserIdent.Lib","type":"module"},{"doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#get/2","title":"Rivet.Ident.UserIdent.Lib.get/2","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#put/3","title":"Rivet.Ident.UserIdent.Lib.put/3","type":"function"},{"doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#t:ecto_p_result/0","title":"Rivet.Ident.UserIdent.Lib.ecto_p_result/0","type":"type"},{"doc":"","ref":"Rivet.Ident.UserIdent.Lib.html#t:model_p_result/0","title":"Rivet.Ident.UserIdent.Lib.model_p_result/0","type":"type"}]